package com.unis.app.controller;

import com.unis.accountability.businessmanagement.client.MangerRulesForClient;
import com.unis.accountability.businessmanagement.common.vo.manageRuler.MangerRulesReceviceVO;
import com.unis.accountability.businessmanagement.common.vo.manageRuler.MangerRulesVO;
import com.unis.common.utils.CurrentUtil;
import com.unis.common.utils.ResponseWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
/**
 * 粮食与物资储备管理制度
 * @author liuweilong
 */
@RestController
@RequestMapping("/cbl/client/MaterialManagement")
@Api(value = "粮食与物资储备管理制度", tags = "粮食与物资储备管理制度")
public class MangerRulesController {

	@Autowired
	private MangerRulesForClient mangerRulesForClient;

	/**
	 * 
	 * @Title: insert @Description: TODO(这里用一句话描述这个方法的作用) @param @param
	 * vo @param @return 参数 @return ResponseWrapper 返回类型 @throws
	 */
	@ApiOperation(value = "保存")
	@PostMapping("/save")
	public ResponseWrapper insert(@RequestBody MangerRulesVO vo) {

		return mangerRulesForClient.insert(vo);
	}

	/**
	 * 
	 * @Title: update @Description: TODO(这里用一句话描述这个方法的作用) @param @param
	 * vo @param @return 参数 @return ResponseWrapper 返回类型 @throws
	 */
	@ApiOperation(value = "编辑")
	@PostMapping("/update")
	public ResponseWrapper update(@RequestBody MangerRulesVO vo) {

		return mangerRulesForClient.update(vo);

	}

	/**
	 * 
	 * @Title: issue @Description: TODO(这里用一句话描述这个方法的作用) @param @param
	 * vo @param @return 参数 @return ResponseWrapper 返回类型 @throws
	 */
	@ApiOperation(value = "下发")
	@PostMapping("/issue")
	public ResponseWrapper issue(@RequestBody MangerRulesReceviceVO vo) {

		return mangerRulesForClient.issue(vo);

	}

	/**
	 * 下载
	 * 
	 * @param response
	 * @param realPath
	 * @return
	 *//*
		 * @ApiOperation(value = "下载")
		 * 
		 * @PostMapping("/downLoad/{realPath}") public ResponseWrapper
		 * downLoad(HttpServletResponse response, @PathVariable("realPath") String
		 * realPath) {
		 * 
		 * return mangerRulesForClient.downLoad(response, realPath);
		 * 
		 * }
		 */

	/**
	 * 删除
	 * 
	 * @param zdbm
	 * @return
	 */
	@ApiOperation(value = "删除")
	@GetMapping("/delete/{zdbm}")
	public ResponseWrapper delete(@PathVariable("zdbm") String zdbm) {

		return mangerRulesForClient.delete(zdbm);

	}

	/**
	 * 
	     * @Title: getInformation
	     * @Description: TODO(这里用一句话描述这个方法的作用)
	     * @param @param zdbm
	     * @param @return 参数
	     * @return ResponseWrapper 返回类型
	     * @throws
	 */
	@ApiOperation(value = "查看")
	@GetMapping("/getInformation/{zdbm}")
	public ResponseWrapper getInformation(@PathVariable("zdbm") String zdbm) {

		return mangerRulesForClient.getInformation(zdbm);

	}

	/**
	 * 
	     * @Title: selectList
	     * @Description: TODO(这里用一句话描述这个方法的作用)
	     * @param @param pageNum
	     * @param @param pageSize
	     * @param @param wjmc(文件名称)
	     * @param @param scrq(上传日期)
	     * @param @return 参数
	     * @return ResponseWrapper 返回类型
	     * @throws
	 */
	@ApiOperation(value = "查询列表")
	@PostMapping("/selectList")
	public ResponseWrapper selectList(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum,
			@RequestParam(value = "pageSize", defaultValue = "10") int pageSize,
			@RequestParam(value = "wjmc", required = false) String wjmc,
			@RequestParam(value = "scrq", required = false) String scrq,
			@RequestBody List<String> orgCode) {

		String orgId = CurrentUtil.getOrgId();
		return mangerRulesForClient.selectList(pageNum, pageSize, wjmc, scrq,orgId,orgCode);

	}
	
	 /**
	  * 
	      * @Title: getJsbmByzdbm
	      * @Description: 根据zdbm获取接收部门编码
	      * @param @param zdbm
	      * @param @return 参数
	      * @return ResponseWrapper 返回类型
	      * @throws
	  */
	 @ApiOperation(value = "根据主表Id获取接收部门id")
	 @GetMapping("/getJsbm/{zdbm}")
	 public ResponseWrapper getJsbmByzdbm(@PathVariable("zdbm")String zdbm) {
		 
		 return mangerRulesForClient.getJsbmByzdbm(zdbm);
		 
		 
	 }

}
