package com.unis.app.service;


import com.unis.accountability.businessmanagement.common.vo.cityQtbm.CityQtbmPage;
import com.unis.accountability.businessmanagement.common.vo.cityQtbm.CityQtbmPageVO;
import com.unis.accountability.businessmanagement.common.vo.cityQtbm.CityTaskinfoVO;
import com.unis.accountability.businessmanagement.common.vo.cityQtbm.QtbmVO;
import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.CityZpbmPublishVO;
import com.unis.common.utils.ResponseWrapper;

import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/9/21 0021 16:09
 * @Description:
 */
public interface BizRespCityQtbmService {
    /**
     * 粮食安全行政首长责任制----市级牵头部门----分页
     * @param cityQtbmPage
     * @param page
     * @param size
     * @return
     */
    Map findByPage(CityQtbmPage cityQtbmPage, Integer page, Integer size);

    /**
     * 粮食安全行政首长责任制----市级牵头部门----查看
     * @param id
     * @return
     */
    CityTaskVO findById(String id);

    /**
     * 粮食安全行政首长责任制----市级牵头部门---编辑
     * @param qtbmVO
     * @return
     */
    ResponseWrapper update(QtbmVO qtbmVO);

    /**
     * 粮食安全行政首长责任制----市级牵头部门---发布
     * @param id
     * @return
     */
    ResponseWrapper publish(String id);

    /**
     * 粮食安全行政首长责任制----市级牵头部门---批量发布
     * @param year
     * @return
     */
    ResponseWrapper publishALL( CityZpbmPublishVO cityZpbmPublishVO);

    /**
     * 粮食安全行政首长责任制----市级牵头部门---提交比例
     * @param year
     * @return
     */
    Map findByTaskDistributionRatio(String year);

    /**
     * 粮食安全行政首长责任制----市级牵头部门---根据年份部门状态查询明细
     * @param cityQtbmPage
     * @return
     */
    List<CityQtbmPageVO> fidByYearAndDeptIdAndStatus(CityQtbmPage cityQtbmPage);

    /**
     * 粮食安全行政首长责任制----市级牵头部门----根据taskId和行政区划查询查看
     * @param taskId
     * @param areaCode
     * @return
     */
    CityTaskinfoVO findByTaskIdAndAreaCode(String taskId, String areaCode);
}