package com.unis.app.service;

import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskDistributionVO;
import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskPage;
import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskPublishVO;
import com.unis.common.utils.ResponseWrapper;

import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/9/20 0020 15:22
 * @Description:
 */
public interface BizRespCityTaskDistributionService {
    /**
     * 粮食安全行政首长责任制----州市任务分配管理----分页
     * @param cityTaskPage
     * @param page
     * @param size
     * @return
     */
    Map findByPage(CityTaskPage cityTaskPage, Integer page, Integer size);

    /**
     * 粮食安全行政首长责任制----州市任务分配管理----查看
     * @param id
     * @return
     */
    CityTaskDistributionVO findById(String id);

    /**
     * 粮食安全行政首长责任制----州市任务分配管理---编辑
     * @param cityTaskUpdateVO
     * @return
     */
    ResponseWrapper update(CityTaskDistributionVO cityTaskUpdateVO);

    /**
     * 粮食安全行政首长责任制----州市任务分配管理---发布
     * @param id
     */
    ResponseWrapper publish(String id);

    /**
     * 粮食安全行政首长责任制----州市任务分配管理---批量发布
     * @param cityTaskPublishVO
     */
    ResponseWrapper publishALL( CityTaskPublishVO cityTaskPublishVO);

    /**
     * 粮食安全行政首长责任制----州市任务分配管理---分配比例
     * @param year
     * @return
     */
    Map findByTaskDistributionRatio(String  year);

    /**
     * 粮食安全行政首长责任制----区自评查看（市局）----分页
     * @param cityTaskPage
     * @param page
     * @param size
     * @return
     */
    Map findZpCityByPage(CityTaskPage cityTaskPage, Integer page, Integer size);

    /**
     * 粮食安全行政首长责任制----区自评查看（市局）---考核分发
     * @param cityTaskPublishVO
     * @return
     */
    ResponseWrapper publishKhff(CityTaskPublishVO cityTaskPublishVO);

    /**
     * 粮食安全行政首长责任制----区自评查看（市局）---是否考核分发
     * @param cityTaskPublishVO
     * @return
     */
    ResponseWrapper findByIsKhff(CityTaskPublishVO cityTaskPublishVO);

}