package com.unis.app.service;

import com.unis.accountability.businessmanagement.common.vo.CityPublishVO;
import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.CityZpbmPage;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.CityZpbmPageVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.ZpbmVO;
import com.unis.common.utils.ResponseWrapper;

import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/9/21 0021 10:02
 * @Description:
 */
public interface BizRespCityZpbmService {
    /**
     * 粮食安全行政首长责任制----州市自评部门审核----分页
     * @param cityZpbmPage
     * @param page
     * @param size
     * @return
     */
    Map findByPage(CityZpbmPage cityZpbmPage, Integer page, Integer size);

    /**
     * 粮食安全行政首长责任制----州市自评部门审核----查看
     * @param id
     * @return
     */
    CityTaskVO findById(String id);

    /**
     * 粮食安全行政首长责任制----州市自评部门审核---编辑
     * @param zpbmVO
     * @return
     */
    ResponseWrapper update(ZpbmVO zpbmVO);

    /**
     * 粮食安全行政首长责任制----州市自评部门审核---发布
     * @param id
     * @return
     */
    ResponseWrapper publish(String id);

    /**
     * 粮食安全行政首长责任制----州市自评部门审核---批量发布
     * @param year
     * @return
     */
    ResponseWrapper publishALL(String year);
    ResponseWrapper publishALL(String year,String status);

    /**
     * 粮食安全行政首长责任制----州市自评部门审核---提交比例
     * @param year
     * @param areaCode
     * @return
     */
    Map findByTaskDistributionRatio(String year, String type, String areaCode);

    /**
     * 粮食安全行政首长责任制----州市自评部门审核---根据年份部门状态查询明细
     * @param cityZpbmPage
     * @return
     */
    List<CityZpbmPageVO> fidByYearAndDeptIdAndStatus(CityZpbmPage cityZpbmPage);

    /**
     * "粮食安全行政首长责任制----州市自评部门审核----根据taskId和行政区划查询查看
     * @param taskId
     * @param areaCode
     * @return
     */
    ZpbmVO findByTaskIdAndAreaCode(String taskId, String areaCode);
    ResponseWrapper updateStatus(CityPublishVO cityPublishVO);
}