package com.unis.app.service;

import com.unis.accountability.businessmanagement.common.vo.provinceTask.ProvinceCityTaskPage;
import com.unis.accountability.businessmanagement.common.vo.provinceTask.ProvinceTaskPage;
import com.unis.accountability.businessmanagement.common.vo.provinceTask.ProvinceTaskVO;
import com.unis.common.utils.ResponseWrapper;

import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/9/23 0023 17:31
 * @Description:
 */
public interface BizRespProvinceTaskService {
    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)----分页
     * @param provinceTaskPage
     * @param page
     * @param size
     * @return
     */
    Map findByPage(ProvinceTaskPage provinceTaskPage, Integer page, Integer size);

    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)----州市考核明细
     * @param provinceTaskPage
     * @param page
     * @param size
     * @return
     */
    Map findCityByPage(ProvinceCityTaskPage provinceTaskPage, Integer page, Integer size);
    /**
     * 粮食安全行政首长责任制----结果汇总查看（市局)----分页
     * @param provinceTaskPage
     * @param page
     * @param size
     * @return
     */
    Map findByHzPage(ProvinceTaskPage provinceTaskPage, Integer page, Integer size);

    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)---驳回
     * @param taskId
     * @return
     */
    ResponseWrapper saveReappraisal(String taskId,String shiAreaCode);

    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)---省级配合部门和牵头部门评价明细
     * @param taskId
     * @param shiAreaCode
     * @return
     */
    ProvinceTaskVO findByProvinceQtbmAndPhbm(String taskId, String shiAreaCode);

    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)---提交
     * @param provinceCityTaskPage
     * @return
     */
    ResponseWrapper publish(ProvinceCityTaskPage provinceCityTaskPage);

    /**
     * 粮食安全行政首长责任制----考核结果查看（市局)---抽查分发
     * @param provinceCityTaskPage
     * @return
     */
    ResponseWrapper publishCcFf(List<ProvinceCityTaskPage> provinceCityTaskPage);


}