package com.unis.app.service;

import com.unis.accountability.businessmanagement.common.vo.responsibility.*;
import com.unis.common.utils.ResponseWrapper;

import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/9/18 0018 11:20
 * @Description:
 */
public interface BizRespResponsibilityService {
    /**
     * 考核评分表管理---分页查询
     * @param pageVO
     * @param page
     * @param size
     * @return
     */
    ResponseWrapper findByPage(BizRespResponsibilityPageVO pageVO, Integer page, Integer size);
    /**
     * 考核评分表管理------根据评分表名称和年分查询数据是否存在
     *
     * @return ResponseWrapper
     */
    ResponseWrapper findByPfbmc(BizRespResponsibilityPfbmcVO pfbmcVO);


    /**
     * 考核评分表管理------根据id查询明细
     * @param id
     * @return
     */
    ResponseWrapper findById(String year,String id);

    /**
     * 考核评分表管理------删除责任考核
     * @param ids
     * @return
     */
    ResponseWrapper deletes(String ids);


    /**
     * 考核评分表管理---保存
     * @param bilityVO
     * @return
     */
    ResponseWrapper save(BilityVO bilityVO);

    /**
     * 考核评分表管理---发布
     * @param id
     * @return
     */
    ResponseWrapper publish(PublishVO publishVO);

    /**
     * 考核评分表管理---下级州市
     * @param cityVO
     * @return
     */
    Map findByRespResponsibilityCity(BizRespResponsibilityCityVO cityVO);

    /**
     * 考核评分表管理---更新评分表
     * @param updateVO
     * @return
     */
    ResponseWrapper updatePfb(BizRespResponsibilityUpdateVO updateVO);

    /**
     * 考核评分表管理------根据ID查询基本信息
     * @param id
     * @return
     */
    BizRespResponsibilityVO findByInfo(String id);

    /**
     * 考核评分表管理----根据id查询明细
     * @param id
     * @return
     */
    BizRespResponsibilityVO findByIds(String id);

    /**
     * 考核评分表管理---下发评表明细
     * @param pageVO
     * @return
     */
    ResponseWrapper findByRespResponsibilityInfo(BizRespResponsibilityPageVO pageVO);

    /**
     * 考核评分表管理------复制评分表
     * @param copyPfbVO
     * @return
     */
    ResponseWrapper saveCopyPfb(BizRespCopyPfbVO copyPfbVO);

    /**
     * 考核评分表管理---状态
     * @return
     */
    List<Map> findByStatus();


    /**
     * 考核评分表管理---编辑
     * @param bilityVO
     * @return
     */
    ResponseWrapper updtae(BilityVO bilityVO);

    /**
     * 考核评分表管理------根据年分查询基本信息
     * @param year
     * @return
     */
    BizRespResponsibilityVO findByYear(String year);
}