package com.unis.app.service;

import com.unis.accountability.businessmanagement.common.vo.cityQtbm.CityTaskinfoVO;
import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskPublishVO;
import com.unis.accountability.businessmanagement.common.vo.examinationTask.BizRespExaminationTaskVO;
import com.unis.accountability.businessmanagement.common.vo.respScoreInput.BizRespScoreInputSmiitVO;
import com.unis.accountability.businessmanagement.common.vo.respScoreInput.BizRespScoreInputVO;
import com.unis.accountability.businessmanagement.common.vo.responsibility.BizRespResponsibilityPageVO;
import com.unis.common.utils.ResponseWrapper;

import java.util.List;

/**
 * @Auther:张新亮
 * @Date: 2019/9/19 0019 15:44
 * @Description:
 */
public interface BizRespScoreInputService {
    /**
     * 粮食安全首长责任制--州市考核任务管理----发布
     * @param id
     */
    void publish(String id);

    /**
     * 粮食安全首长责任制--州市考核任务管理  根据年分 状态 行政区划 查询 州市考核录入数据
     * @param cityTaskPublishVO
     * @return
     */
    List<BizRespScoreInputVO> findByYearAndStatusAndAreaCode(CityTaskPublishVO cityTaskPublishVO);

    /**
     * 粮食安全首长责任制--下发州市考核任务----制定州市考核任务--- 分页
     * @param bizRespResponsibilityPageVO
     * @param page
     * @param size
     * @return
     */
    ResponseWrapper findByPage(BizRespResponsibilityPageVO bizRespResponsibilityPageVO, Integer page, Integer size);

    /**
     * 粮食安全行政首长责任制----市级配合部门 牵头部门 自评部门----查看
     * @param id
     * @param areaCode
     * @return
     */
    CityTaskinfoVO findByQtbmAndPhbmAndZpbm(String taskId, String areaCode);

    /**
     * 州市、外部单位牵头部门、配合部门评分--查询是否可以提交数据dd
     * @param type
     * @param year
     * @return
     */
    ResponseWrapper findByIsSubmit(BizRespScoreInputSmiitVO scoreInputSmiitVO);

    /**
     * 区科室考核
     * @param id
     * @return
     */
    BizRespExaminationTaskVO findByInputId(String id);
}