package com.unis.app.service;

import com.unis.accountability.businessmanagement.common.vo.scoringWeight.BizRespScoringWeightPageVO;
import com.unis.accountability.businessmanagement.common.vo.scoringWeight.WeightVO;
import com.unis.common.utils.ResponseWrapper;

/**
 * @Auther:张新亮
 * @Date: 2019/9/17 0017 18:23
 * @Description:
 */
public interface BizRespScoringWeightService {


    /**
     * 考核评分权重--考核等级设置
     * @param type
     * @param id
     * @return
     */
    ResponseWrapper findByWeightRank(String type, String id);

    /**
     * 考核评分权重--查询可选年分
     * @return
     */
    ResponseWrapper findByYear(String type);

    /**
     * 考核评分权重--查询复制评分表可选年分
     * @param year
     * @return
     */
    ResponseWrapper findByCopyYear();

    /**
     *  根据年分和状态---考核评分权重--对象
     * @return
     */
    ResponseWrapper findByYearAndStatus(Integer year, Integer status);

    /**
     * 保存数据---核评分权重
     * @param weightVO
     * @return ResponseWrapper
     */
    ResponseWrapper save(WeightVO weightVO);

    /**
     * 核评分权重----分页
     * @param
     * @param size
     * @return
     */
    ResponseWrapper findByPage(BizRespScoringWeightPageVO pageVO, Integer page, Integer size);

    /**
     * 根据id查询考核内容--明细
     * @param id 计划id
     * @return
     */
    ResponseWrapper findById(String id);

    /**
     * 保存数据---核评分权重
     * @param weightVO
     * @return ResponseWrapper
     */
    ResponseWrapper update(WeightVO weightVO);

    /**
     * 发布
     * @param
     * @return ResponseWrapper
     */
    ResponseWrapper publish(String id);

    /**
     * 删除考核评分权重
     *
     * @param id
     * @return ResponseWrapper
     */
    ResponseWrapper deletes(String  id);


}