package com.unis.app.service;

import com.unis.accountability.businessmanagement.common.vo.msgNotice.UserDTO;
import com.unis.common.utils.ResponseWrapper;

import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * @Auther:张新亮
 * @Date: 2019/9/19 0019 14:03
 * @Description:
 */
public interface BizRespUserService {
    /**
     *粮食安全省长责任制--省市单位和外部部门 -----查询所有部门
     * @param code
     * @return
     */
    List<Map> findByQtbmAndPhbm(String areaCode);

    /**
     * 粮食安全省长责任制--州市-----自评部门
     * @param code
     * @return
     */
    List<Map> findByZpbm(String orgId);

    /**
     * 粮食安全省长责任制--获取所有省市
     * @return
     */
    List<Map> findDataShiTree();

    /**
     * 获取自评部门名字
     * @param zpbm
     * @return
     */
    String findByZpbmName(String zpbm,String orgId);

    /**
     * 获取配合部门名字
     * @param phbm
     * @return
     */
    String findByPhbmName(String zpbm,String orgId);

    /**
     * 获取牵头部门名字
     * @param qtbm
     * @return
     */
    String findByQtbmName(String qtbm,String orgId);


    /**
     * 删除最后一个字符
     * @param sb
     * @return
     */
    String deleteCharAt(StringBuffer sb);

    /**
     * 行政区划转换
     * @param shiAreaCode
     * @return
     */
    String getCity(List<String> shiAreaCode);

    /**
     * 粮食安全省长责任制--获取所有省市--农业区和非农业区
     * @return
     */
    Map findNyqAndFnyq();


    /**
     * 粮食安全省长责任制--获取省市所有部门信息--非树
     * @return
     */
    List<Map> findByAllDept();


    /**
     * 部门信息划转换
     * @param deptList
     * @return
     */
    String getDept(List<String> deptList,String areaCode);

    /**
     * 粮食安全省长责任制--获取省市所有部门信息--树
     * @return
     */
    List<Map> findByDeptTree();

    /**
     * 查询区划类型
     * @param areaCode
     * @return
     */
    String getAreaCodeType(String areaCode);

    /**
     * 粮食安全省长责任制--评分表分处室考核（市部门）--考核处室
     * @return
     */
    Set<Map> findByUserTree();

    /**
     * 根据组织编号获取本单位名字
     * @param orgId
     * @return
     */
    String findByCode(String orgId);

    /**
     * "粮食安全省长责任制--省市单位和外部部门 -----组织机构树
     * @param orgCode
     * @return
     */
    List<Map> getAllOrgDescendantsTree(String orgCode);

    /**
     * 粮食安全行政首长责任制----部门用户管理----保存
     * @param userDTO
     * @return
     */
    ResponseWrapper saveOrg(UserDTO userDTO);

    /**
     * 粮食安全行政首长责任制----部门用户管理 市区----根据orgCode查询orgName
     * @param userDTO
     * @return
     */
    ResponseWrapper orgNameByCode(UserDTO userDTO);

    /**
     * 粮食安全行政首长责任制----部门用户管理 市区----根据userCode查询orgName
     * @param userDTO
     * @return
     */
    ResponseWrapper findByUserCode(UserDTO userDTO);

    /**
     * 粮食安全行政首长责任制----部门用户管理 市区----保存
     * @param userDTO
     * @return
     */
    ResponseWrapper saveDept(UserDTO userDTO);

    /**
     * 粮食安全行政首长责任制----部门用户管理 市区----根据deptCode查询deptName
     * @param userDTO
     * @return
     */
    ResponseWrapper findByDeptNameByCode(UserDTO userDTO);

    /**
     * 粮食安全省长责任制------所有机构树
     * @return
     */
    List<Map> findByOrgTree();

}