package com.unis.app.service.Impl;


import com.alibaba.fastjson.JSON;
import com.unis.accountability.businessmanagement.client.BizRespCityPhbmClient;
import com.unis.accountability.businessmanagement.client.BizRespCityQtbmClient;
import com.unis.accountability.businessmanagement.common.vo.FileVO;
import com.unis.accountability.businessmanagement.common.vo.cityPhbm.PhbmVO;
import com.unis.accountability.businessmanagement.common.vo.cityQtbm.*;
import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.CityZpbmPublishVO;
import com.unis.app.service.BizRespCityQtbmService;
import com.unis.app.service.BizRespCityZpbmService;
import com.unis.app.service.BizRespFileService;
import com.unis.app.service.BizRespUserService;
import com.unis.common.utils.CurrentUtil;
import com.unis.common.utils.ResponseWrapper;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * @Auther:张新亮
 * @Date: 2019/9/21 0021 18:14
 * @Description:
 */
@Service
public class BizRespCityQtbmServiceImpl implements BizRespCityQtbmService {
    @Autowired
    private BizRespCityQtbmClient bizRespCityQtbmClient;
    @Autowired
    private BizRespUserService bizRespUserService;
    @Autowired
    private BizRespCityZpbmService bizRespCityZpbmService;

    @Autowired
    private BizRespCityPhbmClient bizRespCityPhbmClient;
    @Autowired
    private BizRespFileService bizRespFileService;


    /**
     * 粮食安全行政首长责任制----市级牵头部门----分页
     * @param cityQtbmPage
     * @param page
     * @param size
     * @return
     */
    @Override
    public Map findByPage(CityQtbmPage cityQtbmPage, Integer page, Integer size) {
       // cityQtbmPage.setDeptId(CurrentUtil.getOrgId());
        if(CurrentUtil.getDeptId().length()==5){
            System.out.println("=========================使用 orgId 查询数据=========================");
            cityQtbmPage.setDeptId(CurrentUtil.getOrgId());
        }else{
            System.out.println("=========================使用 userCode 查询数据=========================");
            cityQtbmPage.setDeptId(CurrentUtil.getOrgId());
            cityQtbmPage.setUserCode(CurrentUtil.getUserId());
        }
        ResponseWrapper responseWrapper=bizRespCityQtbmClient.findByPage(cityQtbmPage,page,size);
        String dataJson= (String) responseWrapper.getData();
        Map map= JSON.parseObject(dataJson, Map.class);
        if(map!=null){
            String listJson=JSON.toJSONString(map.get("list"));
            List<CityQtbmPageVO> mapList= JSON.parseArray(listJson, CityQtbmPageVO.class);
            for(CityQtbmPageVO pageVO:mapList){
                StringBuffer sb=new StringBuffer();
                String qtbm=bizRespUserService.findByQtbmName(pageVO.getQtbm(), CurrentUtil.getAreaCode());
                pageVO.setQtbm(qtbm);
                String phbm=bizRespUserService.findByPhbmName(pageVO.getPhbm(), CurrentUtil.getAreaCode());
                pageVO.setPhbm(phbm);
                List<String> phbmList=(List<String>) pageVO.getMap().get("phbmList");
                if(phbmList.size()>0){
                    sb.append("*配合部门").append("（");
                    String deptName=bizRespUserService.getDept(phbmList,pageVO.getAreaCode());
                    sb.append(deptName).append("）");
                }
                if(sb.length()>0){
                    pageVO.setIfTb("no");
                    sb.append("*未上报数据，不可评分！");
                }else{
                    pageVO.setIfTb("yes");
                }
                pageVO.setMessage(sb.toString());
            }
            map.put("list", mapList);
        }
        return map;
    }

    /**
     * 粮食安全行政首长责任制----市级牵头部门----查看
     * @param id
     * @return
     */
    @Override
    public CityTaskVO findById(String id) {
        String deptId=CurrentUtil.getOrgId();
        //考核任务 自评部门
        CityTaskVO cityTaskVO=bizRespCityZpbmService.findById(id);
        //牵头部门
        ResponseWrapper responseWrapper=bizRespCityQtbmClient.findById(id, deptId);
        String dataJson= (String) responseWrapper.getData();
        QtbmVO qtbmVO= JSON.parseObject(dataJson, QtbmVO.class);
        String qtbm=bizRespUserService.findByPhbmName(qtbmVO.getQtbm(),qtbmVO.getAreaCode());
        qtbmVO.setQtbm(qtbm);
        String areaeCodeType=bizRespUserService.getAreaCodeType(qtbmVO.getAreaCode());
        // fnyq  非农业区 nyq 农业区
        qtbmVO.setAreaCodeType(areaeCodeType);
        if(StringUtils.isNotEmpty(qtbmVO.getFileId())){
            //上传文件的信息
            List<FileVO> fileVOList=bizRespFileService.getFileInfo(qtbmVO.getFileId());
            String fileName=fileVOList.get(0).getFileName();
            qtbmVO.setFileName(fileName);
        }
        cityTaskVO.setQtbmVO(qtbmVO);
        if(StringUtils.isNotEmpty(qtbmVO.getPhbm())){
            String[] qhbmList=qtbmVO.getPhbm().split(",");
            List<PhbmVO> phbmVOList=new ArrayList();
            for(String phbm:qhbmList){
                ResponseWrapper resultPhbm=bizRespCityPhbmClient.findById(id, phbm);
                if(resultPhbm.getInfoCode()==200){
                    String dataPhbm= (String) resultPhbm.getData();
                    PhbmVO phbmVO= JSON.parseObject(dataPhbm, PhbmVO.class);
                    String phbmName=bizRespUserService.findByPhbmName(phbmVO.getPhbm(),phbmVO.getAreaCode());
                    phbmVO.setPhbm(phbmName);
                    if(StringUtils.isNotEmpty(phbmVO.getFileId())){
                        //上传文件的信息
                        List<FileVO> fileVOList=bizRespFileService.getFileInfo(phbmVO.getFileId());
                        String fileName=fileVOList.get(0).getFileName();
                        phbmVO.setFileName(fileName);
                    }
                    phbmVOList.add(phbmVO);
                }
            }
            cityTaskVO.setPhbmVOList(phbmVOList);
        }


        return cityTaskVO;
    }

    /**
     * 粮食安全行政首长责任制----市级牵头部门---编辑
     * @param qtbmVO
     * @return
     */
    @Override
    public ResponseWrapper update(QtbmVO qtbmVO) {
        QtbmUpdateVO qtbmUpdateVO=new QtbmUpdateVO();
        qtbmUpdateVO.setQtbmVO(qtbmVO);
        qtbmUpdateVO.setUpdateBy(CurrentUtil.getUserName());
        return  bizRespCityQtbmClient.update(qtbmUpdateVO);
    }

    /**
     * 粮食安全行政首长责任制----市级牵头部门---发布
     * @param id
     * @return
     */
    @Override
    public ResponseWrapper publish(String id) {
        CityZpbmPublishVO cityZpbmPublishVO=new CityZpbmPublishVO();
        cityZpbmPublishVO.setId(id);
        cityZpbmPublishVO.setDeptId(CurrentUtil.getOrgId());
        cityZpbmPublishVO.setUpdateBy(CurrentUtil.getUserName());
        return  bizRespCityQtbmClient.publish(cityZpbmPublishVO);
    }

    /**
     * 粮食安全行政首长责任制----市级牵头部门---批量发布
     * @return
     */
    @Override
    public ResponseWrapper publishALL( CityZpbmPublishVO cityZpbmPublishVO) {
        cityZpbmPublishVO.setDeptId(CurrentUtil.getOrgId());
        cityZpbmPublishVO.setUpdateBy(CurrentUtil.getUserName());
        return  bizRespCityQtbmClient.publishALL(cityZpbmPublishVO);
    }


    /**
     * 粮食安全行政首长责任制----市级牵头部门---提交比例
     * @param year
     * @return
     */
    @Override
    public Map findByTaskDistributionRatio(String year) {
        Map result=new HashMap();
        CityQtbmPage cityQtbmPage=new CityQtbmPage();
        cityQtbmPage.setDeptId(CurrentUtil.getOrgId());
        cityQtbmPage.setYear(year);
        //总数
        List<CityQtbmPageVO> totalNumber= fidByYearAndDeptIdAndStatus(cityQtbmPage);
        result.put("totalNumber", totalNumber.size());
        //未录入
        cityQtbmPage.setStatus("10");
        List<CityQtbmPageVO> wlr= fidByYearAndDeptIdAndStatus(cityQtbmPage);
        result.put("wlr",wlr.size());
        //已录入
        cityQtbmPage.setStatus("20");
        List<CityQtbmPageVO> ylr= fidByYearAndDeptIdAndStatus(cityQtbmPage);
        result.put("ylr",ylr.size());
        //已提交
        cityQtbmPage.setStatus("30");
        List<CityQtbmPageVO> ytj= fidByYearAndDeptIdAndStatus(cityQtbmPage);
        result.put("ytj",ytj.size());
        return result;
    }

    /**
     * 粮食安全行政首长责任制----市级牵头部门---根据年份部门状态查询明细
     * @param cityQtbmPage
     * @return
     */
    @Override
    public List<CityQtbmPageVO> fidByYearAndDeptIdAndStatus(CityQtbmPage cityQtbmPage) {
        ResponseWrapper responseWrapper= bizRespCityQtbmClient.fidByYearAndDeptIdAndStatus(cityQtbmPage);
        String dataJson= (String) responseWrapper.getData();
        List<CityQtbmPageVO> cityZpbmPageVOList= JSON.parseArray(dataJson, CityQtbmPageVO.class);
        return cityZpbmPageVOList;
    }

    /**
     * 粮食安全行政首长责任制----市级牵头部门----根据taskId和行政区划查询查看
     * @param taskId
     * @param areaCode
     * @return
     */
    @Override
    public CityTaskinfoVO findByTaskIdAndAreaCode(String taskId, String areaCode) {
        //牵头部门
        ResponseWrapper responseWrapper=bizRespCityQtbmClient.findByTaskIdAndAreaCode(taskId, areaCode);
        String dataJson= (String) responseWrapper.getData();
        CityTaskinfoVO opionVOs= JSON.parseObject(dataJson, CityTaskinfoVO.class);

        //区集合数据
        for(QtbmOpionVO qtbmOpionVO:opionVOs.getOpionVOList()){
            String deptName=bizRespUserService.findByPhbmName(qtbmOpionVO.getDeptId(),qtbmOpionVO.getAreaCode());
            qtbmOpionVO.setDeptName(deptName);
            if(StringUtils.isNotEmpty(qtbmOpionVO.getFileId())){
                //上传文件的信息
                List<FileVO> fileVOList=bizRespFileService.getFileInfo(qtbmOpionVO.getFileId());
                String fileName=fileVOList.get(0).getFileName();
                qtbmOpionVO.setFileName(fileName);
            }
        }

        //市集合数据
        for(QtbmOpionVO qtbmOpionVO:opionVOs.getCityVOList()){
            String deptName=bizRespUserService.findByPhbmName(qtbmOpionVO.getDeptId(),qtbmOpionVO.getAreaCode());
            qtbmOpionVO.setDeptName(deptName);
            if(StringUtils.isNotEmpty(qtbmOpionVO.getFileId())){
                //上传文件的信息
                List<FileVO> fileVOList=bizRespFileService.getFileInfo(qtbmOpionVO.getFileId());
                String fileName=fileVOList.get(0).getFileName();
                qtbmOpionVO.setFileName(fileName);
            }
        }


        //市抽查集合数据
        for(QtbmOpionVO qtbmOpionVO:opionVOs.getCcCityVOList()){
            String deptName=bizRespUserService.findByPhbmName(qtbmOpionVO.getDeptId(),qtbmOpionVO.getAreaCode());
            qtbmOpionVO.setDeptName(deptName);
            if(StringUtils.isNotEmpty(qtbmOpionVO.getFileId())){
                //上传文件的信息
                List<FileVO> fileVOList=bizRespFileService.getFileInfo(qtbmOpionVO.getFileId());
                String fileName=fileVOList.get(0).getFileName();
                qtbmOpionVO.setFileName(fileName);
            }
        }


        if(StringUtils.isNotEmpty(opionVOs.getCityPhbm())){
            String cityPhbm=bizRespUserService.findByPhbmName(opionVOs.getCityPhbm(),opionVOs.getCityAreaCode());
            opionVOs.setCityPhbm(cityPhbm);
        }

        if(StringUtils.isNotEmpty(opionVOs.getCityQtbm())){
            String cityQtbm=bizRespUserService.findByQtbmName(opionVOs.getCityQtbm(), opionVOs.getCityAreaCode());
            opionVOs.setCityQtbm(cityQtbm);
        }
        if(StringUtils.isNotEmpty(opionVOs.getPhbm())){
            String phbm=bizRespUserService.findByPhbmName(opionVOs.getPhbm(), opionVOs.getAreaCode());
            opionVOs.setPhbm(phbm);
        }
        if(StringUtils.isNotEmpty(opionVOs.getQtbm())){
            String qtbm=bizRespUserService.findByQtbmName(opionVOs.getQtbm(), opionVOs.getAreaCode());
            opionVOs.setQtbm(qtbm);
        }
        return opionVOs;
    }
}