package com.unis.app.service.Impl;

import com.alibaba.fastjson.JSON;
import com.unis.accountability.businessmanagement.client.BizRespCityTaskfFClient;
import com.unis.accountability.businessmanagement.common.vo.cityFf.*;
import com.unis.accountability.businessmanagement.common.vo.examinationTask.BizRespExaminationTaskVO;
import com.unis.app.service.BizRespCityTaskfFService;
import com.unis.app.service.BizRespScoreInputService;
import com.unis.app.service.BizRespUserService;
import com.unis.common.utils.CurrentUtil;
import com.unis.common.utils.ResponseWrapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/12/13 0013 15:24
 * @Description:
 */
@Service
public class BizRespCityTaskfFServiceImpl implements BizRespCityTaskfFService {
    @Autowired
    private BizRespCityTaskfFClient bizRespCityTaskfFClient;
    @Autowired
    private BizRespUserService bizRespUserService;
    @Autowired
    private BizRespScoreInputService bizRespScoreInputService;

    /**
     * 粮食安全行政首长责任制----评分表分处室考核（市部门）----分页
     * @param cityFfPage
     * @param page
     * @param size
     * @return
     */
    @Override
    public Map findByPage(
            CityFfPage cityFfPage,
            Integer page,
            Integer size
    ) {
        cityFfPage.setOrgId(CurrentUtil.getOrgId());
        ResponseWrapper responseWrapper=bizRespCityTaskfFClient.findByPage(cityFfPage,page,size);
        String dataJson= (String) responseWrapper.getData();
        Map map= JSON.parseObject(dataJson, Map.class);
        if(map!=null){
            String listJson=JSON.toJSONString(map.get("list"));
            List<CityFfPageVO> mapList= JSON.parseArray(listJson, CityFfPageVO.class);
            for(CityFfPageVO pageVO:mapList){
                String phbm=bizRespUserService.findByPhbmName(pageVO.getPhbm(),pageVO.getCityAreaCode());
                String qtbm=bizRespUserService.findByQtbmName(pageVO.getQtbm(), pageVO.getCityAreaCode());
                BizRespExaminationTaskVO khcs = bizRespScoreInputService.findByInputId(pageVO.getId());
                pageVO.setPhbm(phbm);
                pageVO.setQtbm(qtbm);
                pageVO.setKhcs(khcs.getKhcs());
            }
            map.put("list", mapList);
        }
        return map;
    }


    /**
     * 粮食安全行政首长责任制----评分表分处室考核（市部门）----查看
     * @param id
     * @return
     */
    @Override
    public TaskFfInfoVO findById(String id) {
        ResponseWrapper responseWrapper=bizRespCityTaskfFClient.findById(id);
        String dataJson= (String) responseWrapper.getData();
        TaskFfInfoVO taskFfInfoVO= JSON.parseObject(dataJson, TaskFfInfoVO.class);
        String phbm=bizRespUserService.findByPhbmName(taskFfInfoVO.getPhbm(),taskFfInfoVO.getCityAreaCode());
        String qtbm=bizRespUserService.findByQtbmName(taskFfInfoVO.getQtbm(), taskFfInfoVO.getCityAreaCode());
        taskFfInfoVO.setPhbm(phbm);
        taskFfInfoVO.setQtbm(qtbm);
        return taskFfInfoVO;
    }

    /**
     * 粮食安全行政首长责任制-----评分表分处室考核（市部门）---编辑
     * @param ffVO
     * @return
     */
    @Override
    public ResponseWrapper update(FfVO ffVO) {
        FfUpdateVO ffUpdateVO=new FfUpdateVO();
        ffUpdateVO.setFfVO(ffVO);
        ffUpdateVO.setUpdateBy(CurrentUtil.getUserName());
        return  bizRespCityTaskfFClient.update(ffUpdateVO);
    }

    /**
     * 粮食安全行政首长责任制----评分表分处室考核（市部门）---发布
     * @param id
     * @return
     */
    @Override
    public ResponseWrapper publish(String id) {
        FfPublishVO ffPublishVO=new FfPublishVO();
        ffPublishVO.setId(id);
        ffPublishVO.setOrgId(CurrentUtil.getOrgId());
        ffPublishVO.setUpdateBy(CurrentUtil.getUserName());
        return  bizRespCityTaskfFClient.publish(ffPublishVO);
    }

    /**
     * 粮食安全行政首长责任制----市级配合部门---批量发布
     * @param ffPublishVO
     * @return
     */
    @Override
    public ResponseWrapper publishALL(FfPublishVO ffPublishVO) {
        ffPublishVO.setOrgId(CurrentUtil.getOrgId());
        ffPublishVO.setUpdateBy(CurrentUtil.getUserName());
        ffPublishVO.setStatus("20");
        return  bizRespCityTaskfFClient.publishALL(ffPublishVO);
    }


    /**
     *  粮食安全行政首长责任制----评分表分处室考核（市部门）--查询是否可以提交数据
     * @param ffPublishVO
     * @return
     */
    @Override
    public ResponseWrapper findByIsSubmit(FfPublishVO ffPublishVO) {
        ffPublishVO.setOrgId(CurrentUtil.getOrgId());
        ffPublishVO.setUpdateBy(CurrentUtil.getUserName());
        ffPublishVO.setStatus("20");
        return  bizRespCityTaskfFClient.findByIsSubmit(ffPublishVO);
    }
}