package com.unis.app.service.Impl;

import com.alibaba.fastjson.JSON;
import com.unis.accountability.businessmanagement.client.BizRespCityZpbmClient;
import com.unis.accountability.businessmanagement.common.vo.CityPublishVO;
import com.unis.accountability.businessmanagement.common.vo.FileVO;
import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.*;
import com.unis.accountability.businessmanagement.common.vo.examinationTask.TaskInfoVO;
import com.unis.app.service.BizRespCityZpbmService;
import com.unis.app.service.BizRespExaminationTaskService;
import com.unis.app.service.BizRespFileService;
import com.unis.app.service.BizRespUserService;
import com.unis.common.utils.CurrentUtil;
import com.unis.common.utils.ResponseWrapper;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/9/21 0021 10:02
 * @Description:
 */
@Service
public class BizRespCityZpbmServiceImpl implements BizRespCityZpbmService {
    @Autowired
    private BizRespCityZpbmClient bizRespCityZpbmClient;
    @Autowired
    private BizRespUserService bizRespUserService;
    @Autowired
    private BizRespExaminationTaskService bizRespExaminationTaskService;
    @Autowired
    private BizRespFileService bizRespFileService;

    /**
     * 粮食安全行政首长责任制----州市自评部门审核----分页
     * @param cityZpbmPage
     * @param page
     * @param size
     * @return
     */
    @Override
    public Map findByPage(CityZpbmPage cityZpbmPage, Integer page, Integer size) {
        if(StringUtils.isEmpty(cityZpbmPage.getAreaCode())){
            cityZpbmPage.setAreaCode(CurrentUtil.getAreaCode());
        }
        if(CurrentUtil.getDeptId().length()==5){
            System.out.println("=========================使用 orgId 查询数据=========================");
            cityZpbmPage.setDeptId(CurrentUtil.getOrgId());
        }else{
            System.out.println("=========================使用 userCode 查询数据=========================");
            cityZpbmPage.setUserCode(CurrentUtil.getUserId());
        }
        ResponseWrapper responseWrapper=bizRespCityZpbmClient.findByPage(cityZpbmPage,page,size);
        String dataJson= (String) responseWrapper.getData();
        Map map= JSON.parseObject(dataJson, Map.class);
        if(map!=null){
            String listJson=JSON.toJSONString(map.get("list"));
            List<CityZpbmPageVO> mapList= JSON.parseArray(listJson, CityZpbmPageVO.class);
            for(CityZpbmPageVO pageVO:mapList){
                String qtbm=bizRespUserService.findByPhbmName(pageVO.getQtbm(), pageVO.getAreaCode());
                pageVO.setQtbm(qtbm);
                String phbm=bizRespUserService.findByPhbmName(pageVO.getPhbm(),pageVO.getAreaCode());
                pageVO.setPhbm(phbm);
                String cityQtbm=bizRespUserService.findByPhbmName(pageVO.getCityQtbm(), pageVO.getCityAreacode());
                pageVO.setCityQtbm(cityQtbm);
                String cityPhbm=bizRespUserService.findByPhbmName(pageVO.getCityPhbm(),pageVO.getCityAreacode());
                pageVO.setCityPhbm(cityPhbm);
            }
            map.put("list", mapList);
        }
        return map;
    }


    /**
     * 粮食安全行政首长责任制----州市自评部门审核----查看
     * @param id
     * @return
     */
    @Override
    public CityTaskVO findById(String id) {
        CityTaskVO cityTaskVO=new CityTaskVO();
        ResponseWrapper responseWrapper=bizRespCityZpbmClient.findById(id);
        String dataJson= (String) responseWrapper.getData();
        ZpbmVO zpbmVO= JSON.parseObject(dataJson, ZpbmVO.class);
        TaskInfoVO taskInfoVO=bizRespExaminationTaskService.findByTaskInfo(zpbmVO.getBizResexaminationTaskId());
        cityTaskVO.setZpbm(zpbmVO);
        cityTaskVO.setTaskInfo(taskInfoVO);
        return cityTaskVO;
    }


    /**
     * 粮食安全行政首长责任制----州市自评部门审核---编辑
     * @param zpbmVO
     * @return
     */
    @Override
    public ResponseWrapper update(ZpbmVO zpbmVO) {
        ZpbmUpdateVO zpbmUpdateVO=new ZpbmUpdateVO();
        zpbmUpdateVO.setZpbmVO(zpbmVO);
        zpbmUpdateVO.setUpdateBy(CurrentUtil.getUserName());
        return  bizRespCityZpbmClient.update(zpbmUpdateVO);
    }

    /**
     * 粮食安全行政首长责任制----州市自评部门审核---发布
     * @param id
     * @return
     */
    @Override
    public ResponseWrapper publish(String id) {
        CityZpbmPublishVO cityZpbmPublishVO=new CityZpbmPublishVO();
        cityZpbmPublishVO.setId(id);
        cityZpbmPublishVO.setDeptId(CurrentUtil.getDeptId());
        cityZpbmPublishVO.setUpdateBy(CurrentUtil.getUserName());
        return  bizRespCityZpbmClient.publish(cityZpbmPublishVO);
    }

    @Override
    public ResponseWrapper updateStatus(CityPublishVO cityPublishVO) {
        cityPublishVO.setDeptId(CurrentUtil.getDeptId());
        cityPublishVO.setUpdateBy(CurrentUtil.getUserName());
        return  bizRespCityZpbmClient.updateStatus(cityPublishVO);
    }

    /**
     * 粮食安全行政首长责任制----州市自评部门审核---批量发布
     * @param year
     * @return
     */
    @Override
    public ResponseWrapper publishALL(String year) {
        CityZpbmPublishVO cityZpbmPublishVO=new CityZpbmPublishVO();
        cityZpbmPublishVO.setDeptId(CurrentUtil.getDeptId());
        cityZpbmPublishVO.setYear(year);
        cityZpbmPublishVO.setUpdateBy(CurrentUtil.getUserName());
        return  bizRespCityZpbmClient.publishALL(cityZpbmPublishVO);
    }
    @Override
    public ResponseWrapper publishALL(String year,String status) {
        CityZpbmPublishVO cityZpbmPublishVO=new CityZpbmPublishVO();
        cityZpbmPublishVO.setDeptId(CurrentUtil.getDeptId());
        if(null != year && "".equals(year)) {
            cityZpbmPublishVO.setYear(year);
        }
        cityZpbmPublishVO.setStatus(status);
        cityZpbmPublishVO.setUpdateBy(CurrentUtil.getUserName());
        return  bizRespCityZpbmClient.publishALL(cityZpbmPublishVO);
    }

    /**
     * 粮食安全行政首长责任制----州市自评部门审核---提交比例
     * @param year
     * @param areaCode
     * @return
     */
    @Override
    public Map findByTaskDistributionRatio(String year, String type, String areaCode) {
        Map result=new HashMap();
        CityZpbmPage cityZpbmPage=new CityZpbmPage();
        cityZpbmPage.setAreaCode(areaCode);
        cityZpbmPage.setYear(year);
        cityZpbmPage.setType(type);
        //总数
        List<CityZpbmPageVO> totalNumber= fidByYearAndDeptIdAndStatus(cityZpbmPage);
        result.put("totalNumber", totalNumber.size());
        //未录入
        cityZpbmPage.setStatus("10");
        List<CityZpbmPageVO> wlr= fidByYearAndDeptIdAndStatus(cityZpbmPage);
        result.put("wlr",wlr.size());
        //已录入
        cityZpbmPage.setStatus("20");
        List<CityZpbmPageVO> ylr= fidByYearAndDeptIdAndStatus(cityZpbmPage);
        result.put("ylr",ylr.size());
        //已提交
        cityZpbmPage.setStatus("30");
        List<CityZpbmPageVO> ytj= fidByYearAndDeptIdAndStatus(cityZpbmPage);
        result.put("ytj",ytj.size());
        return result;
    }

    /**
     * 粮食安全行政首长责任制----州市自评部门审核---根据年份部门状态查询明细
     * @param cityZpbmPage
     * @return
     */
    @Override
    public List<CityZpbmPageVO> fidByYearAndDeptIdAndStatus(CityZpbmPage cityZpbmPage) {
        ResponseWrapper responseWrapper= bizRespCityZpbmClient.fidByYearAndDeptIdAndStatus(cityZpbmPage);
        String dataJson= (String) responseWrapper.getData();
        List<CityZpbmPageVO> cityZpbmPageVOList= JSON.parseArray(dataJson, CityZpbmPageVO.class);
        return cityZpbmPageVOList;
    }

    /**
     * "粮食安全行政首长责任制----州市自评部门审核----根据taskId和行政区划查询查看
     * @param taskId
     * @param areaCode
     * @return
     */
    @Override
    public ZpbmVO findByTaskIdAndAreaCode(String taskId, String areaCode) {
        ResponseWrapper responseWrapper= bizRespCityZpbmClient.findByTaskIdAndAreaCode(taskId,areaCode);
        String dataJson= (String) responseWrapper.getData();
        ZpbmVO zpbmVO= JSON.parseObject(dataJson, ZpbmVO.class);
        //获取自评部门上传文件的信息
        List<FileVO> fileVOList=bizRespFileService.getFileInfo(zpbmVO.getFileId());
        zpbmVO.setFileVOList(fileVOList);
        String zpbm=bizRespUserService.findByZpbmName(zpbmVO.getZpbm(),zpbmVO.getOrgId());
        zpbmVO.setZpbm(zpbm);
        return zpbmVO;

    }


}