package com.unis.app.service.Impl;

import com.unis.accountability.businessmanagement.client.BizRespExaminationContentClient;
import com.unis.accountability.businessmanagement.common.vo.DeleteVO;
import com.unis.accountability.businessmanagement.common.vo.examinationContent.ContentPage;
import com.unis.accountability.businessmanagement.common.vo.examinationContent.ContentSaveVO;
import com.unis.accountability.businessmanagement.common.vo.examinationContent.ContentUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.examinationContent.ContentVO;
import com.unis.app.service.BizRespExaminationContentService;
import com.unis.common.utils.CurrentUtil;
import com.unis.common.utils.ResponseWrapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;



/**粮食安全行政首长责任制----考核内容
 * @Auther:张新亮
 * @Date: 2019/9/18 0018 15:29
 * @Description:
 */
@Service
public class BizRespExaminationContentServiceImpl implements BizRespExaminationContentService {
    @Autowired
    private BizRespExaminationContentClient bizRespExaminationContentClient;

    /**
     * 粮食安全行政首长责任制----考核内容----保存
     * @param contentVO
     * @return
     */
    @Override
    public ResponseWrapper save(ContentVO contentVO) {
        ContentSaveVO saveVO=new ContentSaveVO();
        saveVO.setCreateBy(CurrentUtil.getUserName());
        saveVO.setAreaCode(CurrentUtil.getAreaCode());
        saveVO.setOrgId(CurrentUtil.getOrgId());
        saveVO.setDeptId(CurrentUtil.getDeptId());
        saveVO.setContentVO(contentVO);
        return bizRespExaminationContentClient.save(saveVO);
    }

    /**
     * 粮食安全行政首长责任制----考核内容----分页
     * @param contentPage
     * @param page
     * @param size
     * @return
     */
    @Override
    public ResponseWrapper findByPage(ContentPage contentPage, Integer page, Integer size) {
        contentPage.setOrgId(CurrentUtil.getOrgId());
        return bizRespExaminationContentClient.findByPage(contentPage,page,size);
    }

    /**
     * 粮食安全行政首长责任制----考核内容----修改
     * @param contentVO
     * @return
     */
    @Override
    public ResponseWrapper update(ContentVO contentVO) {
        ContentUpdateVO updateVO=new ContentUpdateVO();
        updateVO.setUpdateBy(CurrentUtil.getUserName());
        updateVO.setContentVO(contentVO);
        return bizRespExaminationContentClient.update(updateVO);
    }

    /**
     * 粮食安全行政首长责任制----考核内容----删除
     * @param ids
     * @return
     */
    @Override
    public ResponseWrapper deletes(String[] ids) {
        DeleteVO deleteVO=new DeleteVO();
        deleteVO.setIds(ids);
        deleteVO.setDeleteBy(CurrentUtil.getUserName());
        return bizRespExaminationContentClient.deletes(deleteVO);
    }


    /**
     * 粮食安全行政首长责任制----考核内容----根据年份year和组织机构查询好喝内容
     * @param year
     * @param responsibilityId
     * @return
     */
    @Override
    public ResponseWrapper findByYearAndOrgId(String year, String responsibilityId) {
        String orgId=CurrentUtil.getOrgId();
      return   bizRespExaminationContentClient.findByYearAndOrgId(year,responsibilityId,orgId);
    }
}