package com.unis.app.service.Impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.unis.accountability.businessmanagement.client.BizRespExaminationExcelClient;
import com.unis.accountability.businessmanagement.client.BizRespScoringWeightClient;
import com.unis.accountability.businessmanagement.common.utils.ExcelFileVO;
import com.unis.accountability.businessmanagement.common.vo.examinationExcel.*;
import com.unis.accountability.businessmanagement.common.vo.responsibility.BizRespResponsibilityVO;
import com.unis.accountability.businessmanagement.common.vo.scoringWeight.BizRespScoringWeightVO;
import com.unis.app.service.BizRespExaminationExcelService;
import com.unis.app.service.BizRespResponsibilityService;
import com.unis.app.service.BizRespUserService;
import com.unis.common.utils.CurrentUtil;
import com.unis.common.utils.ResponseWrapper;
import org.apache.commons.lang.StringUtils;
import org.apache.poi.hssf.usermodel.*;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.ss.util.CellRangeAddress;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.InputStream;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/9/24 0024 17:31
 * @Description:
 */
@Service
@SuppressWarnings("all")
public class BizRespExaminationExcelServiceImpl implements BizRespExaminationExcelService {
    @Autowired
    private BizRespExaminationExcelClient bizRespExaminationExcelClient;
    @Autowired
    private BizRespUserService bizRespUserService;
    @Autowired
    private BizRespResponsibilityService bizRespResponsibilityService;
    @Autowired
    private BizRespScoringWeightClient bizRespScoringWeightClient;


    /**
     * 粮食安全行政首长责任制--考核评分表管理)---下载模板
     *
     * @param response
     * @param year     20200225 修改：通用模板不需要添加年度筛选
     */
    @Override
    public void downloadKhpfbExcel(HttpServletResponse response) {
        String nameFile = "天津市粮食安全区长责任制考核评分表 ";
        //1.创建工作簿
        HSSFWorkbook workbook = new HSSFWorkbook();
        //1.1创建合并单元格对象
        CellRangeAddress callRangeAddress = new CellRangeAddress(0, 0, 0, 5);//起始行,结束行,起始列,结束列
        ///大标题
        HSSFCellStyle headStyle = ExcelFileVO.createCellStyle(workbook, (short) 15, false, true);
        //第二行标题样式
        HSSFCellStyle colStyle = ExcelFileVO.createCellStyle(workbook, (short) 10, true, true);
        //内容样式
        HSSFCellStyle cellStyle = ExcelFileVO.createCellStyle(workbook, (short) 10, false, true);
        //2.创建工作表
        HSSFSheet Sheet1 = workbook.createSheet("Sheet1");
        //2.1加载合并单元格对象
        Sheet1.addMergedRegion(callRangeAddress);
        //设置默认列宽
        Sheet1.setDefaultColumnWidth(18);
        //3.创建行
        //3.1创建头标题行;并且设置头标题
        HSSFRow row = Sheet1.createRow(0);
        HSSFCell cell = row.createCell(0);
        row.setHeight((short) 500);//目的是想把行高设置成25px
        //加载单元格样式
        cell.setCellStyle(headStyle);
        cell.setCellValue(nameFile);
        //3.2创建列标题;并且设置列标题
        HSSFRow row2 = Sheet1.createRow(1);
/*        CellRangeAddress khnr = new CellRangeAddress(1, 2, 0, 0);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(khnr);
        CellRangeAddress khsx = new CellRangeAddress(1, 2, 1, 1);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(khsx);
        CellRangeAddress khzb = new CellRangeAddress(1, 2, 2, 2);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(khzb);*/
        CellRangeAddress fz = new CellRangeAddress(1, 1, 1, 2);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(fz);
        CellRangeAddress pbzb = new CellRangeAddress(1, 2, 0, 0);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(pbzb);
        CellRangeAddress pfyj = new CellRangeAddress(1, 2, 5, 5);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(pfyj);
/*        CellRangeAddress khfs = new CellRangeAddress(1, 2, 7, 7);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(khfs);*/
        CellRangeAddress khbm = new CellRangeAddress(1, 1, 3, 4);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(khbm);
       /* //考核内容
        HSSFCell ckhnr = row2.createCell(0);
        ckhnr.setCellStyle(colStyle);
        ckhnr.setCellValue("考核内容");
        //重点考核事项
        HSSFCell ckhsx = row2.createCell(1);
        ckhsx.setCellStyle(colStyle);
        ckhsx.setCellValue("重点考核事项");
        //考核指标
        HSSFCell ckhzn = row2.createCell(2);
        ckhzn.setCellStyle(colStyle);
        ckhzn.setCellValue("考核指标");*/
        //分值
        HSSFCell cfz = row2.createCell(1);
        cfz.setCellStyle(colStyle);
        cfz.setCellValue("分值");
        //评分标准
        HSSFCell cpfzb = row2.createCell(0);
        cpfzb.setCellStyle(colStyle);
        cpfzb.setCellValue("评分标准");
        //评分依据
        HSSFCell cpfyj = row2.createCell(5);
        cpfyj.setCellStyle(colStyle);
        cpfyj.setCellValue("备注");
        //考核方式
/*        HSSFCell ckhfs = row2.createCell(7);
        ckhfs.setCellStyle(colStyle);
        ckhfs.setCellValue("考核方式");*/
        //考核部门
        HSSFCell ckhbm = row2.createCell(3);
        ckhbm.setCellStyle(colStyle);
        ckhbm.setCellValue("考核部门");

        HSSFRow row3 = Sheet1.createRow(2);
        //农业
        HSSFCell cny = row3.createCell(1);
        cny.setCellStyle(colStyle);
        cny.setCellValue("农业区");
        //非农业
        HSSFCell cfny = row3.createCell(2);
        cfny.setCellStyle(colStyle);
        cfny.setCellValue("非农业区");

        //牵头部门
        HSSFCell cqtbm = row3.createCell(3);
        cqtbm.setCellStyle(colStyle);
        cqtbm.setCellValue("牵头部门");
        //配合部门
        HSSFCell cphbm = row3.createCell(4);
        cphbm.setCellStyle(colStyle);
        cphbm.setCellValue("配合部门(单位)");

        String fileName = nameFile;
        try {
            ExcelFileVO.export(fileName, workbook, response);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    /**
     * 粮食安全行政首长责任制----考核评分表管理----导入评分表
     *
     * @param file  上传文件
     * @param year  年份
     * @param pfbmc 评分表名称
     * @return
     */
    @Override
    public Map<String, Object> importKhpfbExcel(
            MultipartFile file,
            String year,
            String pfbmc,
            String fileType
    ) {
        try {
            Map result = new HashMap();
            try {
                InputStream is = file.getInputStream();
                Workbook wb = null;
                if ("xls".equals(fileType)) {
                    wb = new HSSFWorkbook(is);
                }
                if ("xlsx".equals(fileType)) {
                    wb = new XSSFWorkbook(is);
                }
                List<List<String>> list = ExcelFileVO.getExcelRows(ExcelFileVO.getSheet(wb, 0), -1, -1);
                if (list.size() > 3) {
                    //较验excel 表格是否正确
                    boolean cheakData = BizRespExcelNewVO.getCheckMainData(list.get(1), list.get(2));
                    if (cheakData) {
                        //List<BizRespExaminationContentExcelVO> excelVOList = new ArrayList();
                        List<BizRespExaminationTaskExcelVO>  excelVOList = new ArrayList<>();
//                        整理导入省长责任制的数据
                        List<Map> bmList = bizRespUserService.findByQtbmAndPhbm(CurrentUtil.getAreaCode());
                        //result = BizRespExcelVO.getCheckExcelData(list, excelVOList, bmList);
                        result = BizRespExcelNewVO.getCheckExcelData1(list, excelVOList, bmList);
                        String rt = result.get("result").toString();
                        if (rt.equals("2")) {
                            return result;
                        }

                        //BizRespExcelSaveVO saveVO = new BizRespExcelSaveVO();
                        BizRespExcelSaveNewVO saveVO = new BizRespExcelSaveNewVO();
                        saveVO.setYear(year);
                        saveVO.setPfbmc(pfbmc);
                        saveVO.setExcelVOList(excelVOList);
                        saveVO.setOrgId(CurrentUtil.getOrgId());
                        saveVO.setDeptId(CurrentUtil.getDeptId());
                        saveVO.setAreaCode(CurrentUtil.getAreaCode());
                        saveVO.setCreateBy(CurrentUtil.getUserName());
                        //较验数据全部合格之后插入数据库存
                        System.out.println("========================开始保存数据  start====================");
                        ResponseWrapper responseWrapper = bizRespExaminationExcelClient.saveExcleData(saveVO);
                        if (responseWrapper.getInfoCode() == 200) {
                            System.out.println("========================开始保存数据  end====================");
                            result.put("result", "1");
                            result.put("mes", "");
                        } else {
                            result.put("result", "2");
                            result.put("mes", responseWrapper.getMsg());
                        }
                    } else {
                        result.put("result", "2");
                        result.put("mes", "导入数据模板有误，第二行标题，与下载模板不一致!");
                    }
                } else {
                    result.put("result", "2");
                    result.put("mes", "导入数据为空或是导入模板有误，请检查后重新导入！");
                }
            } catch (IOException e) {
                result.put("result", "2");
                result.put("mes", e.getMessage());
                e.printStackTrace();
            }
            return result;

        } catch (Exception e) {
            e.printStackTrace();
        }

        return null;
    }



    /**
     * 粮食安全行政首长责任制----考核评分表管理----导出评分表
     *
     * @param response
     * @param bizRespResponsibilityId
     */
    @Override
    public void exportKhpfbExcel(HttpServletResponse response, String bizRespResponsibilityId) {
        BizRespResponsibilityVO bizRespResponsibilityVO = bizRespResponsibilityService.findByInfo(bizRespResponsibilityId);
        String nameFile = bizRespResponsibilityVO.getPfbmc();
        //1.创建工作簿
        HSSFWorkbook workbook = new HSSFWorkbook();
        //1.1创建合并单元格对象
        CellRangeAddress callRangeAddress = new CellRangeAddress(0, 0, 0, 5);//起始行,结束行,起始列,结束列
        ///大标题
        HSSFCellStyle headStyle = ExcelFileVO.createCellStyle(workbook, (short) 20, false, true);
        //第二行标题样式
        HSSFCellStyle colStyle = ExcelFileVO.createCellStyle(workbook, (short) 10, true, true);
        //内容样式
        HSSFCellStyle cellStyle = ExcelFileVO.createCellStyle(workbook, (short) 10, false, true);
        //2.创建工作表
        HSSFSheet Sheet1 = workbook.createSheet("Sheet1");
        //2.1加载合并单元格对象
        Sheet1.addMergedRegion(callRangeAddress);
        //设置默认列宽
        Sheet1.setDefaultColumnWidth(30);
        //3.创建行
        //3.1创建头标题行;并且设置头标题
        HSSFRow row = Sheet1.createRow(0);
        HSSFCell cell = row.createCell(0);
        row.setHeight((short) 500);//目的是想把行高设置成25px
        //加载单元格样式
        cell.setCellStyle(headStyle);
        cell.setCellValue(nameFile);
        //3.2创建列标题;并且设置列标题
        HSSFRow row2 = Sheet1.createRow(1);
/*        CellRangeAddress h_khnr = new CellRangeAddress(1, 2, 0, 0);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(h_khnr);
        CellRangeAddress h_khsx = new CellRangeAddress(1, 2, 1, 1);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(h_khsx);
        CellRangeAddress h_khzb = new CellRangeAddress(1, 2, 2, 2);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(h_khzb);*/
        CellRangeAddress h_fz = new CellRangeAddress(1, 1, 1, 2);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(h_fz);
        CellRangeAddress h_pbzb = new CellRangeAddress(1, 2, 0, 0);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(h_pbzb);
        CellRangeAddress h_pfyj = new CellRangeAddress(1, 2, 5, 5);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(h_pfyj);
/*        CellRangeAddress h_khfs = new CellRangeAddress(1, 2, 7, 7);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(h_khfs);*/
        CellRangeAddress h_khbm = new CellRangeAddress(1, 1, 3, 4);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(h_khbm);
       /* //考核内容
        HSSFCell ckhnr = row2.createCell(0);
        ckhnr.setCellStyle(colStyle);
        ckhnr.setCellValue("考核内容");
        //重点考核事项
        HSSFCell ckhsx = row2.createCell(1);
        ckhsx.setCellStyle(colStyle);
        ckhsx.setCellValue("重点考核事项");
        //考核指标
        HSSFCell ckhzn = row2.createCell(2);
        ckhzn.setCellStyle(colStyle);
        ckhzn.setCellValue("考核指标");*/
        //分值
        HSSFCell cfz = row2.createCell(1);
        cfz.setCellStyle(colStyle);
        cfz.setCellValue("分值");
        //评分标准
        HSSFCell cpfzb = row2.createCell(0);
        cpfzb.setCellStyle(colStyle);
        cpfzb.setCellValue("评分标准");
        //评分依据
        HSSFCell cpfyj = row2.createCell(5);
        cpfyj.setCellStyle(colStyle);
        cpfyj.setCellValue("备注");
        //考核方式
/*        HSSFCell ckhfs = row2.createCell(7);
        ckhfs.setCellStyle(colStyle);
        ckhfs.setCellValue("考核方式");*/
        //考核部门
        HSSFCell ckhbm = row2.createCell(3);
        ckhbm.setCellStyle(colStyle);
        ckhbm.setCellValue("考核部门");

        HSSFRow row3 = Sheet1.createRow(2);
        //农业
        HSSFCell cny = row3.createCell(1);
        cny.setCellStyle(colStyle);
        cny.setCellValue("农业区");
        //非农业
        HSSFCell cfny = row3.createCell(2);
        cfny.setCellStyle(colStyle);
        cfny.setCellValue("非农业区");

        //牵头部门
        HSSFCell cqtbm = row3.createCell(3);
        cqtbm.setCellStyle(colStyle);
        cqtbm.setCellValue("牵头部门");
        //配合部门
        HSSFCell cphbm = row3.createCell(4);
        cphbm.setCellStyle(colStyle);
        cphbm.setCellValue("配合部门(单位)");


        int khnrHang = 3;
        int khnrNumber = 2;

        int khsxHang = 3;
        int khsxNumber = 2;

        int khzbHang = 3;
        int khzbNumber = 2;

        int khrwHang = 3;
        int khrwNumber = 2;

        List<BizRespExaminationTaskExcelVO> contentExcelData = getContentExcelData(bizRespResponsibilityId);
                    for (BizRespExaminationTaskExcelVO taskExcelVO : contentExcelData) {
                        HSSFRow khrwRow = Sheet1.getRow(khrwHang);
                        if (khrwRow == null) {
                            khrwRow = Sheet1.createRow(khrwHang);
                        }
                        //分值--农业
                        HSSFCell nyCel = khrwRow.createCell(1);
                        nyCel.setCellStyle(cellStyle);
                        nyCel.setCellValue(taskExcelVO.getNyfz());
                        //分值--非农业
                        HSSFCell fnyCel = khrwRow.createCell(2);
                        fnyCel.setCellStyle(cellStyle);
                        fnyCel.setCellValue(taskExcelVO.getFnyfz());

                        //评分标准
                        HSSFCell pfbzCel = khrwRow.createCell(0);
                        pfbzCel.setCellStyle(cellStyle);
                        pfbzCel.setCellValue(taskExcelVO.getScoreStandard());
                        //评分依据
                        HSSFCell pfyjCel = khrwRow.createCell(5);
                        pfyjCel.setCellStyle(cellStyle);
                        pfyjCel.setCellValue(taskExcelVO.getPfyj());
                        //考核方式
/*                        HSSFCell khfsCel = khrwRow.createCell(7);
                        khfsCel.setCellStyle(cellStyle);
                        khfsCel.setCellValue(taskExcelVO.getKhfs());*/
                        //年度考核任务评分标准--牵头部门
                        String qtbm = bizRespUserService.findByQtbmName(taskExcelVO.getLeadDepartment(), bizRespResponsibilityVO.getAreaCode());
                        String qtbmName = qtbm.replaceAll(",", "\n");
                        HSSFCell qtbmCel = khrwRow.createCell(3);
                        qtbmCel.setCellStyle(cellStyle);
                        qtbmCel.setCellValue(qtbmName);
                        //年度考核任务评分标准--配合部门
                        String ph = bizRespUserService.findByPhbmName(taskExcelVO.getCoordinationDepartment(), bizRespResponsibilityVO.getAreaCode());
                        String phbmName = null;
                        if (ph != null) {
                            phbmName = ph.replaceAll(",", "\n");
                        }
                        HSSFCell phbmCel = khrwRow.createCell(4);
                        phbmCel.setCellStyle(cellStyle);
                        phbmCel.setCellValue(phbmName);
                        khrwHang++;
                    }
        String fileName = nameFile;
        try {
            ExcelFileVO.export(fileName, workbook, response);
        } catch (IOException e) {
            e.printStackTrace();
        }


    }


    /**
     * 粮食安全行政首长责任制----考核评分表管理----评分表数据
     *
     * @param ids
     * @return
     */
    private List<BizRespExaminationTaskExcelVO> getContentExcelData(String bizRespResponsibilityId) {
        ResponseWrapper responseWrapper = bizRespExaminationExcelClient.exportKhpfbExcel(bizRespResponsibilityId);
        String dataJson = (String) responseWrapper.getData();
        List<BizRespExaminationTaskExcelVO> mapList = JSON.parseArray(dataJson, BizRespExaminationTaskExcelVO.class);
        return mapList;
    }

    /**
     * 粮食安全行政首长责任制--区自评查看（区粮办）---导出
     *
     * @param response
     * @param year
     * @param shiAreaCode
     * @param bizRespResponsibilityId
     * @param tag 1:区自评查看 2:考核结果查看 3:抽查结果查看 4:结果汇总查看
     */
    @Override
    public void exportAreaExcel(
            HttpServletResponse response,
            AreeExcelVO areeExcelVO,
            Integer tag
    ) {
        BizRespResponsibilityVO bizRespResponsibilityVO = bizRespResponsibilityService.findByYear(areeExcelVO.getYear());
        String nameFile = bizRespResponsibilityVO.getPfbmc();
        //1.创建工作簿
        HSSFWorkbook workbook = new HSSFWorkbook();
        //1.1创建合并单元格对象
        int lastCol;
        if (tag == 1) {
            lastCol = 8;
        } else if (tag == 2) {
            lastCol = 9;
        } else if (tag == 3) {
            lastCol = 10;
        } else {
            lastCol = 11;
        }
        CellRangeAddress callRangeAddress = new CellRangeAddress(0, 0, 0, lastCol);//起始行,结束行,起始列,结束列
        ///大标题
        HSSFCellStyle headStyle = ExcelFileVO.createCellStyle(workbook, (short) 20, false, true);
        //第二行标题样式
        HSSFCellStyle colStyle = ExcelFileVO.createCellStyle(workbook, (short) 10, true, true);
        //内容样式
        HSSFCellStyle cellStyle = ExcelFileVO.createCellStyle(workbook, (short) 10, false, true);
        //2.创建工作表
        HSSFSheet Sheet1 = workbook.createSheet("Sheet1");
        //2.1加载合并单元格对象
        Sheet1.addMergedRegion(callRangeAddress);
        //设置默认列宽
        Sheet1.setDefaultColumnWidth(30);
        //3.创建行
        //3.1创建头标题行;并且设置头标题
        HSSFRow row = Sheet1.createRow(0);
        HSSFCell cell = row.createCell(0);
        row.setHeight((short) 500);//目的是想把行高设置成25px
        //加载单元格样式
        cell.setCellStyle(headStyle);
        cell.setCellValue(nameFile);
        //3.2创建列标题;并且设置列标题
        HSSFRow row2 = Sheet1.createRow(1);
        //考核内容
       /* CellRangeAddress h_khnr = new CellRangeAddress(1, 2, 0, 0);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(h_khnr);
        HSSFCell ckhnr = row2.createCell(0);
        ckhnr.setCellStyle(colStyle);
        ckhnr.setCellValue("考核内容");*/
        //重点考核事项
/*        CellRangeAddress h_khsx = new CellRangeAddress(1, 2, 1, 1);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(h_khsx);
        HSSFCell ckhsx = row2.createCell(1);
        ckhsx.setCellStyle(colStyle);
        ckhsx.setCellValue("重点考核事项");*/
        //考核指标
/*        CellRangeAddress h_khzb = new CellRangeAddress(1, 2, 2, 2);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(h_khzb);
        HSSFCell ckhzn = row2.createCell(2);
        ckhzn.setCellStyle(colStyle);
        ckhzn.setCellValue("考核指标");*/
        //分值
        CellRangeAddress h_fz = new CellRangeAddress(1, 1, 1, 2);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(h_fz);
        HSSFCell cfz = row2.createCell(1);
        cfz.setCellStyle(colStyle);
        cfz.setCellValue("分值");
        //评分标准
        CellRangeAddress h_pbzb = new CellRangeAddress(1, 2, 0, 0);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(h_pbzb);
        HSSFCell cpfzb = row2.createCell(0);
        cpfzb.setCellStyle(colStyle);
        cpfzb.setCellValue("评分标准");
        //评分依据
        CellRangeAddress h_pfyj = new CellRangeAddress(1, 2, 7, 7);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(h_pfyj);
        HSSFCell cpfyj = row2.createCell(7);
        cpfyj.setCellStyle(colStyle);
        cpfyj.setCellValue("备注");
        //考核方式
/*        CellRangeAddress h_khfs = new CellRangeAddress(1, 2, 7, 7);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(h_khfs);
        HSSFCell ckhfs = row2.createCell(7);
        ckhfs.setCellStyle(colStyle);
        ckhfs.setCellValue("考核方式");*/
        //考核部门
        CellRangeAddress h_khbm = new CellRangeAddress(1, 1, 3, 4);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(h_khbm);
        HSSFCell ckhbm = row2.createCell(3);
        ckhbm.setCellStyle(colStyle);
        ckhbm.setCellValue("考核部门");
        //3.3创建第三行并设置固定列标题
        HSSFRow row3 = Sheet1.createRow(2);
        //农业
        HSSFCell cny = row3.createCell(1);
        cny.setCellStyle(colStyle);
        cny.setCellValue("农业区");
        //非农业
        HSSFCell cfny = row3.createCell(2);
        cfny.setCellStyle(colStyle);
        cfny.setCellValue("非农业区");
        //市牵头部门
        HSSFCell cqtbm = row3.createCell(3);
        cqtbm.setCellStyle(colStyle);
        cqtbm.setCellValue("牵头部门");
        //市配合部门
        HSSFCell cphbm = row3.createCell(4);
        cphbm.setCellStyle(colStyle);
        cphbm.setCellValue("配合部门(单位)");
        //说明：到此固定的列标题设置完成，此后需要根据不同的查看页面设置不同的列标题
        if (tag == 1) {
            //区自评查看
            //自评部门
            setQzpBt(Sheet1, row2, row3, colStyle, 5);
        } else if (tag == 2) {
            //考核结果查看
            //考核得分
            CellRangeAddress khfz_fz = new CellRangeAddress(1, 2, 9, 9);//起始行,结束行,起始列,结束列
            Sheet1.addMergedRegion(khfz_fz);
            HSSFCell cityKhff = row2.createCell(9);
            cityKhff.setCellStyle(colStyle);
            cityKhff.setCellValue("考核得分");
            //设置自评部门、自评得分列标题
            setQzpBt(Sheet1, row2, row3, colStyle, 5);
        } else if (tag == 3 || tag == 4) {
            //抽查结果查看
            //设置考核得分、抽查得分、自评部门、自评得分列标题
            setCcjgBt(Sheet1, row2, row3, colStyle, 9);
            if (tag == 4) {
                //综合得分
                CellRangeAddress khfz_fz = new CellRangeAddress(1, 2, 11, 11);//起始行,结束行,起始列,结束列
                Sheet1.addMergedRegion(khfz_fz);
                HSSFCell cityKhff = row2.createCell(11);
                cityKhff.setCellStyle(colStyle);
                cityKhff.setCellValue("综合得分");
            }
        }

        int khnrHang = 3;
        int khnrNumber = 2;

        int khsxHang = 3;
        int khsxNumber = 2;

        int khzbHang = 3;
        int khzbNumber = 2;

        int khrwHang = 3;
        int khrwNumber = 3;

        List<BizRespExaminationTaskExcelVO> taskExcelVOS = getAreaContentExcelData(areeExcelVO);
            HSSFRow contentRow = Sheet1.createRow(khnrHang);

                    for (BizRespExaminationTaskExcelVO taskExcelVO : taskExcelVOS) {
                        HSSFRow khrwRow = Sheet1.getRow(khrwHang);
                        if (khrwRow == null) {
                            khrwRow = Sheet1.createRow(khrwHang);
                        }
                        //分值--农业
                        HSSFCell nyCel = khrwRow.createCell(1);
                        nyCel.setCellStyle(cellStyle);
                        nyCel.setCellValue(taskExcelVO.getNyfz());
                        //分值--非农业
                        HSSFCell fnyCel = khrwRow.createCell(2);
                        fnyCel.setCellStyle(cellStyle);
                        fnyCel.setCellValue(taskExcelVO.getFnyfz());

                        //评分标准
                        HSSFCell pfbzCel = khrwRow.createCell(0);
                        pfbzCel.setCellStyle(cellStyle);
                        pfbzCel.setCellValue(taskExcelVO.getScoreStandard());
                        //评分依据
                        HSSFCell pfyjCel = khrwRow.createCell(7);
                        pfyjCel.setCellStyle(cellStyle);
                        pfyjCel.setCellValue(taskExcelVO.getPfyj());
                        //考核方式
   /*                     HSSFCell khfsCel = khrwRow.createCell(7);
                        khfsCel.setCellStyle(cellStyle);
                        khfsCel.setCellValue(taskExcelVO.getKhfs());
*/

                        //年度考核任务评分标准--牵头部门
                        String qtbm = bizRespUserService.findByQtbmName(taskExcelVO.getLeadDepartment(), taskExcelVO.getCityAreaCode());
                        String qtbmName = qtbm.replaceAll(",", "\n");
                        HSSFCell qtbmCel = khrwRow.createCell(3);
                        qtbmCel.setCellStyle(cellStyle);
                        qtbmCel.setCellValue(qtbmName);
                        //年度考核任务评分标准--配合部门
                        String ph = bizRespUserService.findByPhbmName(taskExcelVO.getCoordinationDepartment(), taskExcelVO.getCityAreaCode());
                        String phbmName = null;
                        if (ph != null) {
                            phbmName = ph.replaceAll(",", "\n");
                        }
                        HSSFCell phbmCel = khrwRow.createCell(4);
                        phbmCel.setCellStyle(cellStyle);
                        phbmCel.setCellValue(phbmName);

                        if (tag == 1) {
                            //区自评查看
                            setQzpSj(taskExcelVO, khrwRow, cellStyle, 5);
                        } else if (tag == 2) {
                            //考核结果查看
                            //市考核得分
                            HSSFCell kkdfCel = khrwRow.createCell(9);
                            kkdfCel.setCellStyle(cellStyle);
                            if (taskExcelVO.getKhdfScore() != null) {
                                kkdfCel.setCellValue(taskExcelVO.getKhdfScore());
                            }
                            setQzpSj(taskExcelVO, khrwRow, cellStyle, 5);
                        } else if (tag == 3 || tag == 4) {
                            //抽查结果查看
                            //市考核得分
                            HSSFCell kkdfCel = khrwRow.createCell(9);
                            kkdfCel.setCellStyle(cellStyle);
                            if (taskExcelVO.getKhdfScore() != null) {
                                kkdfCel.setCellValue(taskExcelVO.getKhdfScore());
                            }
                            //抽查得分
                            HSSFCell ccdfCel = khrwRow.createCell(10);
                            ccdfCel.setCellStyle(cellStyle);
                            if (taskExcelVO.getCcScore() != null) {
                                ccdfCel.setCellValue(taskExcelVO.getCcScore());
                            }
                            setQzpSj(taskExcelVO, khrwRow, cellStyle, 5);
                            if (tag == 4) {
                                Double zhdf = getZhdfSj(taskExcelVO, areeExcelVO.getYear());
                                HSSFCell zhdfCel = khrwRow.createCell(11);
                                zhdfCel.setCellStyle(cellStyle);
                                if (zhdf != null) {
                                    zhdfCel.setCellValue(zhdf);
                                }
                            }
                        }
                        khrwHang++;
                    }

        String fileName = nameFile;
        try {
            ExcelFileVO.export(fileName, workbook, response);
        } catch (IOException e) {
            e.printStackTrace();
        }

    }

    /**
     * 区导出查询数居
     *
     * @param cityZpbmPage
     * @return
     */
    private List<BizRespExaminationTaskExcelVO> getAreaContentExcelData(AreeExcelVO areeExcelVO) {
        ResponseWrapper responseWrapper = bizRespExaminationExcelClient.exportAreaExcel(areeExcelVO);
        String dataJson = (String) responseWrapper.getData();
        List<BizRespExaminationTaskExcelVO> mapList = JSON.parseArray(dataJson, BizRespExaminationTaskExcelVO.class);
        return mapList;
    }

    /**
     * 设置区自评查看页excel导出需设置的列标题
     *
     * @param Sheet1
     * @param row2
     * @param row3
     * @param colStyle
     * @param startColumn
     */
    private void setQzpBt(HSSFSheet Sheet1, HSSFRow row2, HSSFRow row3, HSSFCellStyle colStyle, int startColumn) {
        //自评部门
        CellRangeAddress h_zpbm = new CellRangeAddress(1, 1, startColumn, startColumn + 1);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(h_zpbm);
        HSSFCell czpbm = row2.createCell(startColumn);
        czpbm.setCellStyle(colStyle);
        czpbm.setCellValue("自评部门");
        //区牵头部门
        HSSFCell qqtbm = row3.createCell(startColumn);
        qqtbm.setCellStyle(colStyle);
        qqtbm.setCellValue("牵头部门");
        //区配合部门
        HSSFCell qphbm = row3.createCell(startColumn + 1);
        qphbm.setCellStyle(colStyle);
        qphbm.setCellValue("配合部门(单位)");
        //自评得分
        CellRangeAddress h_zpfz = new CellRangeAddress(1, 2, startColumn + 3, startColumn + 3);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(h_zpfz);
        //自评得分
        HSSFCell czpbmfz = row2.createCell(startColumn + 3);
        czpbmfz.setCellStyle(colStyle);
        czpbmfz.setCellValue("自评得分");
    }

    /**
     * 设置抽查结果查看页excel导出需设置的列标题
     *
     * @param Sheet1
     * @param row2
     * @param row3
     * @param colStyle
     * @param startColumn
     */
    private void setCcjgBt(HSSFSheet Sheet1, HSSFRow row2, HSSFRow row3, HSSFCellStyle colStyle, int startColumn) {
        //考核得分
        CellRangeAddress khfz_fz = new CellRangeAddress(1, 2, startColumn, startColumn);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(khfz_fz);
        HSSFCell cityKhff = row2.createCell(startColumn);
        cityKhff.setCellStyle(colStyle);
        cityKhff.setCellValue("考核得分");
        //抽查得分
        CellRangeAddress cc_fz = new CellRangeAddress(1, 2, startColumn + 1, startColumn + 1);//起始行,结束行,起始列,结束列
        Sheet1.addMergedRegion(cc_fz);
        //抽查得分
        HSSFCell cityccdf = row2.createCell(startColumn + 1);
        cityccdf.setCellStyle(colStyle);
        cityccdf.setCellValue("抽查得分");
        //设置自评部门、自评得分列
        setQzpBt(Sheet1, row2, row3, colStyle, 5);

    }

    /**
     * 设置区自评查看页excel导出需设置的列标题
     *
     * @param taskExcelVO
     * @param khrwRow
     * @param cellStyle
     * @param startColumn
     */
    private void setQzpSj(BizRespExaminationTaskExcelVO taskExcelVO, HSSFRow khrwRow, HSSFCellStyle cellStyle, int startColumn) {
        //区--牵头部门
        String q_qtbm = bizRespUserService.findByQtbmName(taskExcelVO.getQtbm(), taskExcelVO.getAreaCode());
        String q_qtbmName = null;
        if (StringUtils.isNotEmpty(q_qtbm)) {
            q_qtbmName = q_qtbm.replaceAll(",", "\n");
        }
        HSSFCell q_qtbmCel = khrwRow.createCell(startColumn);
        q_qtbmCel.setCellStyle(cellStyle);
        q_qtbmCel.setCellValue(q_qtbmName);

        //区--配合部门
        String q_ph = bizRespUserService.findByPhbmName(taskExcelVO.getPhbm(), taskExcelVO.getAreaCode());
        String q_phbmName = null;
        if (StringUtils.isNotEmpty(q_ph)) {
            q_phbmName = q_ph.replaceAll(",", "\n");
        }
        HSSFCell q_phbmCel = khrwRow.createCell(startColumn + 1);
        q_phbmCel.setCellStyle(cellStyle);
        q_phbmCel.setCellValue(q_phbmName);

        //自评得分
        HSSFCell q_zpdf = khrwRow.createCell(startColumn + 3);
        q_zpdf.setCellStyle(cellStyle);
        if (taskExcelVO.getScore() != null) {
            q_zpdf.setCellValue(taskExcelVO.getScore());
        }
    }

    /**
     * 结果汇总查看页excel导出中综合得分项数据获取
     *
     * @param taskExcelVO
     * @param year
     * @return
     */
    private Double getZhdfSj(BizRespExaminationTaskExcelVO taskExcelVO, String year) {
        Double zhdf = 0.0;
        //区级完成分数
        Double qj_wcfs = taskExcelVO.getScore() == null ? 0.0 : taskExcelVO.getScore();
        //市级完成分数
        Double sj_wcfs = taskExcelVO.getKhdfScore() == null ? 0.0 : taskExcelVO.getKhdfScore();
        //抽查市级完成分数
        Double cc_sj_wcfs = taskExcelVO.getCcScore() == null ? 0.0 : taskExcelVO.getCcScore();
        //统计分值
        ResponseWrapper responseWrapper = bizRespScoringWeightClient.findByYearAndStatus(Integer.valueOf(year), 1);
        String dataJson = JSONObject.toJSONString(responseWrapper.getData());
        BizRespScoringWeightVO bizRespScoringWeight = JSON.parseObject(dataJson, BizRespScoringWeightVO.class);
        /**
         * 统计综合得分--抽查分值
         */
        if (taskExcelVO.getCcScore() != null) {
            //区级分值 zsZpbmWeight
            Double zsZpbmWeight = Double.valueOf(bizRespScoringWeight.getZsZpbmWeight());
            Double qjScore = (zsZpbmWeight / 100) * qj_wcfs;
            System.out.println("区级牵头部门总分==" + qj_wcfs + "权重:" + zsZpbmWeight + "统计结果:" + qjScore);
            //市级分值 zsZpbmWeight
            Double sjQtbmWeight = Double.valueOf(bizRespScoringWeight.getSjQtbmWeight());
            Double sjScore = (sjQtbmWeight / 100) * sj_wcfs;
            System.out.println("市级牵头部门总分==" + sj_wcfs + "权重:" + sjQtbmWeight + "统计结果:" + sjScore);

            //市级分值 sjQtbmFpWeight
            Double sjQtbmFpWeight = Double.valueOf(bizRespScoringWeight.getSjQtbmFpWeight());
            Double ccScore = (sjQtbmFpWeight / 100) * cc_sj_wcfs;
            System.out.println("市级牵头部门总分==" + cc_sj_wcfs + "权重:" + sjQtbmWeight + "统计结果:" + ccScore);

            BigDecimal bd = new BigDecimal(qjScore + sjScore + ccScore);
            zhdf = bd.setScale(2, BigDecimal.ROUND_HALF_UP).doubleValue();
            return zhdf;
        } else {
            //区级分值 zsZpbmWeight
            Double zsZpbmWeight = Double.valueOf(bizRespScoringWeight.getZsZpbmWeight());
            Double qjScore = (zsZpbmWeight / 100) * qj_wcfs;
            System.out.println("区级牵头部门总分==" + qj_wcfs + "权重:" + zsZpbmWeight + "统计结果:" + qjScore);
            //市级分值 zsZpbmWeight
            Double sjQtbmWeight = Double.valueOf(bizRespScoringWeight.getSjQtbmWeight());
            Double qtbmWeight = 100 - zsZpbmWeight - Double.valueOf(bizRespScoringWeight.getSjQtbmWeight());
            System.out.println("==============无抽查数据计算查分比 start==========");
            System.out.println("==============区级百分比==========" + zsZpbmWeight);
            System.out.println("==============市级百分比==========" + sjQtbmWeight);
            System.out.println("==============100-区级百分比-市级百分比==========" + qtbmWeight);
            System.out.println("==============无抽查数据计算查分比 end ==========");
            Double sjScore = ((sjQtbmWeight + qtbmWeight) / 100) * sj_wcfs;
            System.out.println("市级牵头部门总分==" + sj_wcfs + "权重:" + sjQtbmWeight + "统计结果:" + sjScore);
            BigDecimal bd = new BigDecimal(qjScore + sjScore);
            zhdf = bd.setScale(2, BigDecimal.ROUND_HALF_UP).doubleValue();
            return zhdf;
        }
    }

}