package com.unis.app.service.Impl;

import com.unis.accountability.businessmanagement.client.BizRespExaminationItemClient;
import com.unis.accountability.businessmanagement.common.vo.DeleteVO;
import com.unis.accountability.businessmanagement.common.vo.examinationItem.ItemPage;
import com.unis.accountability.businessmanagement.common.vo.examinationItem.ItemSaveVO;
import com.unis.accountability.businessmanagement.common.vo.examinationItem.ItemUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.examinationItem.ItemVO;
import com.unis.app.service.BizRespExaminationItemService;
import com.unis.common.utils.CurrentUtil;
import com.unis.common.utils.ResponseWrapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Auther:张新亮
 * @Date: 2019/9/18 0018 16:16
 * @Description:
 */
@Service
public class BizRespExaminationItemServiceImpl implements BizRespExaminationItemService {
    @Autowired
    private BizRespExaminationItemClient bizRespExaminationItemClient;


    /**
     * 粮食安全行政首长责任制----重点考核事项---保存
     * @param itemVO
     * @return
     */
    @Override
    public ResponseWrapper save(ItemVO itemVO) {
        ItemSaveVO itemSaveVO=new ItemSaveVO();
        itemSaveVO.setCreateBy(CurrentUtil.getUserName());
        itemSaveVO.setAreaCode(CurrentUtil.getAreaCode());
        itemSaveVO.setDeptId(CurrentUtil.getDeptId());
        itemSaveVO.setOrgId(CurrentUtil.getOrgId());
        itemSaveVO.setItemVO(itemVO);
      return   bizRespExaminationItemClient.save(itemSaveVO);
    }

    /**
     * itemPage----重点考核事项---分页
     * @param itemPage
     * @param page
     * @param size
     * @return
     */
    @Override
    public ResponseWrapper findByPage(ItemPage itemPage, Integer page, Integer size) {
        itemPage.setOrgId(CurrentUtil.getOrgId());
        return bizRespExaminationItemClient.findByPage(itemPage,page,size);
    }

    /**
     * 粮食安全行政首长责任制----重点考核事项---编辑
     * @param itemVO
     * @return
     */
    @Override
    public ResponseWrapper update(ItemVO itemVO) {
        ItemUpdateVO itemUpdateVO=new ItemUpdateVO();
        itemUpdateVO.setUpdateBy(CurrentUtil.getUserName());
        itemUpdateVO.setItemVO(itemVO);
        return bizRespExaminationItemClient.update(itemUpdateVO);
    }

    /**
     * 粮食安全行政首长责任制----重点考核事项---批量删除
     * @param ids
     * @return
     */
    @Override
    public ResponseWrapper deletes(String[] ids) {
        DeleteVO deleteVO=new DeleteVO();
        deleteVO.setIds(ids);
        deleteVO.setDeleteBy(CurrentUtil.getUserName());
        return bizRespExaminationItemClient.deletes(deleteVO);
    }

    /**
     * 粮食安全行政首长责任制----重点考核事项---根据年份year和组织机构 orgId 查询重点考核事项
     * @param year
     * @param responsibilityId
     * @return
     */
    @Override
    public ResponseWrapper findByYearAndOrgId(String year, String responsibilityId) {
        String deptId=CurrentUtil.getOrgId();
        return bizRespExaminationItemClient.findByYearAndOrgId(year,responsibilityId,deptId);
    }
}