package com.unis.app.service.Impl;

import com.unis.accountability.businessmanagement.client.BizRespExaminationQuotaClient;
import com.unis.accountability.businessmanagement.common.vo.DeleteVO;
import com.unis.accountability.businessmanagement.common.vo.examinationQuota.QuotaSaveVO;
import com.unis.accountability.businessmanagement.common.vo.examinationQuota.QuotaUPdateVO;
import com.unis.accountability.businessmanagement.common.vo.examinationQuota.QuotaVO;
import com.unis.accountability.businessmanagement.common.vo.examinationQuota.QutoaPage;
import com.unis.app.service.BizRespExaminationQuotaService;
import com.unis.common.utils.CurrentUtil;
import com.unis.common.utils.ResponseWrapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Auther:张新亮
 * @Date: 2019/9/18 0018 16:33
 * @Description:
 */
@Service
public class BizRespExaminationQuotaServiceImpl implements BizRespExaminationQuotaService {

    @Autowired
    private BizRespExaminationQuotaClient bizRespExaminationQuotaClient;

    /**
     * 粮食安全省长责任制--考核指标----保存
     * @param quotaVO
     * @return
     */
    @Override
    public ResponseWrapper save(QuotaVO quotaVO) {
        QuotaSaveVO quotaSaveVO=new QuotaSaveVO();
        quotaSaveVO.setCreateBy(CurrentUtil.getUserName());
        quotaSaveVO.setAreaCode(CurrentUtil.getAreaCode());
        quotaSaveVO.setDeptId(CurrentUtil.getDeptId());
        quotaSaveVO.setOrgId(CurrentUtil.getOrgId());
        quotaSaveVO.setQuotaVO(quotaVO);
        return bizRespExaminationQuotaClient.save(quotaSaveVO);

    }

    /**
     * 粮食安全省长责任制--考核指标----分页
     * @param qutoaPage
     * @param page
     * @param size
     * @return
     */
    @Override
    public ResponseWrapper findByPage(QutoaPage qutoaPage, Integer page, Integer size) {
        qutoaPage.setOrgId(CurrentUtil.getOrgId());
        return bizRespExaminationQuotaClient.findByPage(qutoaPage,page,size);
    }

    /**
     * 粮食安全省长责任制--考核指标----根据年份year和组织机构 orgId 查询重点考核事项
     * @param year
     * @param responsibilityId
     * @return
     */
    @Override
    public ResponseWrapper findByYearAndOrgId(String year, String responsibilityId) {
        String orgId=CurrentUtil.getOrgId();
        return bizRespExaminationQuotaClient.findByYearAndOrgId(year,responsibilityId,orgId);
    }

    /**
     * 粮食安全省长责任制--考核指标----编辑
     * @param quotaVO
     * @return
     */
    @Override
    public ResponseWrapper update(QuotaVO quotaVO) {
        QuotaUPdateVO quotaUPdateVO=new QuotaUPdateVO();
        quotaUPdateVO.setUpdateBy(CurrentUtil.getUserName());
        quotaUPdateVO.setQuotaVO(quotaVO);
        return bizRespExaminationQuotaClient.update(quotaUPdateVO);
    }

    /**
     * 粮食安全省长责任制--考核指标----批量删除
     * @param ids
     * @return
     */
    @Override
    public ResponseWrapper deletes(String[] ids) {
        DeleteVO deleteVO=new DeleteVO();
        deleteVO.setIds(ids);
        deleteVO.setDeleteBy(CurrentUtil.getUserName());
        return bizRespExaminationQuotaClient.deletes(deleteVO);
    }
}