package com.unis.app.service.Impl;

import com.alibaba.fastjson.JSON;
import com.unis.accountability.businessmanagement.client.BizRespProvincePhbmClient;
import com.unis.accountability.businessmanagement.common.vo.FileVO;
import com.unis.accountability.businessmanagement.common.vo.cityPhbm.PhbmUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.cityPhbm.PhbmVO;
import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskVO;
import com.unis.accountability.businessmanagement.common.vo.examinationTask.TaskInfoVO;
import com.unis.accountability.businessmanagement.common.vo.provincePhbm.ProvincePhbmPage;
import com.unis.accountability.businessmanagement.common.vo.provincePhbm.ProvincePhbmPublishVO;
import com.unis.accountability.businessmanagement.common.vo.provincePhbm.PrvoincePhbmPageVO;
import com.unis.app.service.BizRespExaminationTaskService;
import com.unis.app.service.BizRespFileService;
import com.unis.app.service.BizRespProvincePhbmService;
import com.unis.app.service.BizRespUserService;
import com.unis.common.utils.CurrentUtil;
import com.unis.common.utils.ResponseWrapper;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/10/8 0008 16:26
 * @Description:
 */
@Service
public class BizRespProvincePhbmServiceImpl implements BizRespProvincePhbmService {
    @Autowired
    private BizRespProvincePhbmClient bizRespProvincePhbmClient;
    @Autowired
    private BizRespUserService bizRespUserService;
    @Autowired
    private BizRespExaminationTaskService bizRespExaminationTaskService;
    @Autowired
    private BizRespFileService bizRespFileService;
    /**
     * 粮食安全行政首长责任制----省级配合部门----分页
     * @param provincePhbmPage
     * @param page
     * @param size
     * @return
     */
    @Override
    public Map findByPage(ProvincePhbmPage provincePhbmPage, Integer page, Integer size) {
        if(CurrentUtil.getDeptId().length()==5){
            System.out.println("=========================使用 orgId 查询数据=========================");
            provincePhbmPage.setDeptId(CurrentUtil.getOrgId());
        }else{
            System.out.println("=========================使用 userCode 查询数据=========================");
            provincePhbmPage.setUserCode(CurrentUtil.getUserId());
        }
        System.out.println(CurrentUtil.getDeptId());
        ResponseWrapper responseWrapper=bizRespProvincePhbmClient.findByPage(provincePhbmPage,page,size);
        String dataJson= (String) responseWrapper.getData();
        Map map= JSON.parseObject(dataJson, Map.class);
        if(map!=null){
            String listJson=JSON.toJSONString(map.get("list"));
            List<PrvoincePhbmPageVO> mapList= JSON.parseArray(listJson, PrvoincePhbmPageVO.class);
            for(PrvoincePhbmPageVO pageVO:mapList){
                String phbm=bizRespUserService.findByPhbmName(pageVO.getCityPhbm(),pageVO.getShiAreaCode());
                String qtbm=bizRespUserService.findByQtbmName(pageVO.getCityQtbm(), pageVO.getShiAreaCode());
                List<String> shiAreaCode=new ArrayList();
                shiAreaCode.add(pageVO.getAreaCode());
                String cityName=bizRespUserService.getCity(shiAreaCode);
                pageVO.setAreaCodeName(cityName);
                pageVO.setCityPhbm(phbm);
                pageVO.setCityQtbm(qtbm);
            }
            map.put("list", mapList);
        }
        return map;
    }


    /**
     * 粮食安全行政首长责任制----省级配合部门----查看
     * @param id
     * @return
     */
    @Override
    public CityTaskVO findById(String id) {
        CityTaskVO cityTaskVO=new CityTaskVO();
        ResponseWrapper responseWrapper=bizRespProvincePhbmClient.findById(id);
        String dataJson= (String) responseWrapper.getData();
        PhbmVO phbmVO= JSON.parseObject(dataJson, PhbmVO.class);
        String phbm=bizRespUserService.findByPhbmName(phbmVO.getPhbm(), phbmVO.getCityAreacode());
        phbmVO.setPhbm(phbm);
        if(StringUtils.isNotEmpty(phbmVO.getFileId())){
            //上传文件的信息
            List<FileVO> fileVOList=bizRespFileService.getFileInfo(phbmVO.getFileId());
            String fileName=fileVOList.get(0).getFileName();
            phbmVO.setFileName(fileName);
        }
        TaskInfoVO taskInfoVO=bizRespExaminationTaskService.findByTaskInfo(phbmVO.getBizResexaminationTaskId());
        cityTaskVO.setPhbmVO(phbmVO);
        cityTaskVO.setTaskInfo(taskInfoVO);
        return cityTaskVO;
    }


    /**
     * 粮食安全行政首长责任制----省级配合部门---编辑
     * @param phbmVO
     * @return
     */
    @Override
    public ResponseWrapper update(PhbmVO phbmVO) {
        PhbmUpdateVO phbmUpdateVO=new PhbmUpdateVO();
        phbmUpdateVO.setPhbmVO(phbmVO);
        phbmUpdateVO.setUpdateBy(CurrentUtil.getUserName());
       return bizRespProvincePhbmClient.update(phbmUpdateVO);
    }


    /**
     * 粮食安全行政首长责任制----省级配合部门---上报
     * @param id
     * @return
     */
    @Override
    public ResponseWrapper publish(String  id) {
        ProvincePhbmPublishVO phbmPublishVO=new ProvincePhbmPublishVO();
        phbmPublishVO.setId(id);
        phbmPublishVO.setDeptId(CurrentUtil.getOrgId());
        phbmPublishVO.setUpdateBy(CurrentUtil.getUserName());
        return  bizRespProvincePhbmClient.publish(phbmPublishVO);
    }


    /**
     * 粮食安全行政首长责任制----省级配合部门---批量上报
     * @param year
     * @return
     */
    @Override
    public ResponseWrapper publishALL(ProvincePhbmPublishVO phbmPublishVO) {
//        phbmPublishVO.setYear(year);
//        /**
//         * 类型  10 省配合部门  70 省级平时配合部门
//         */
//        phbmPublishVO.setType(type);
        /**
         * 状态：10 未录入 20 已录入  30 已上报
         */
        phbmPublishVO.setStatus("20");
        phbmPublishVO.setDeptId(CurrentUtil.getOrgId());
        phbmPublishVO.setUpdateBy(CurrentUtil.getUserName());
        return  bizRespProvincePhbmClient.publishALL(phbmPublishVO);
    }
}