package com.unis.app.service.Impl;

import com.alibaba.fastjson.JSON;
import com.unis.accountability.businessmanagement.client.BizRespProvinceQtbmClient;
import com.unis.accountability.businessmanagement.common.vo.FileVO;
import com.unis.accountability.businessmanagement.common.vo.cityPhbm.PhbmVO;
import com.unis.accountability.businessmanagement.common.vo.cityQtbm.QtbmUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.cityQtbm.QtbmVO;
import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskVO;
import com.unis.accountability.businessmanagement.common.vo.examinationTask.TaskInfoVO;
import com.unis.accountability.businessmanagement.common.vo.provincePhbm.ProvincePhbmPage;
import com.unis.accountability.businessmanagement.common.vo.provincePhbm.ProvincePhbmPublishVO;
import com.unis.accountability.businessmanagement.common.vo.provincePhbm.PrvoincePhbmPageVO;
import com.unis.app.service.BizRespExaminationTaskService;
import com.unis.app.service.BizRespFileService;
import com.unis.app.service.BizRespProvinceQtbmService;
import com.unis.app.service.BizRespUserService;
import com.unis.common.utils.CurrentUtil;
import com.unis.common.utils.ResponseWrapper;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/10/8 0008 16:26
 * @Description:
 */
@Service
public class BizRespProvinceQtbmServiceImpl implements BizRespProvinceQtbmService {
    @Autowired
    private BizRespProvinceQtbmClient bizRespProvinceQtbmClient;
    @Autowired
    private BizRespUserService bizRespUserService;
    @Autowired
    private BizRespExaminationTaskService bizRespExaminationTaskService;
    @Autowired
    private BizRespFileService bizRespFileService;
    /**
     * 粮食安全行政首长责任制----省级牵头部门----分页
     * @param provincePhbmPage
     * @param page
     * @param size
     * @return
     */
    @Override
    public Map findByPage(ProvincePhbmPage provincePhbmPage, Integer page, Integer size) {
        System.out.println("部门ID=="+CurrentUtil.getDeptId());
        if(CurrentUtil.getDeptId().length()==5){
            System.out.println("=========================使用 orgId 查询数据=========================");
            provincePhbmPage.setDeptId(CurrentUtil.getOrgId());
        }else{
            System.out.println("=========================使用 userCode 查询数据=========================");
            provincePhbmPage.setUserCode(CurrentUtil.getUserId());
        }
        ResponseWrapper responseWrapper=bizRespProvinceQtbmClient.findByPage(provincePhbmPage,page,size);
        String dataJson= (String) responseWrapper.getData();
        Map map= JSON.parseObject(dataJson, Map.class);
        if(map!=null){
            String listJson=JSON.toJSONString(map.get("list"));
            List<PrvoincePhbmPageVO> mapList= JSON.parseArray(listJson, PrvoincePhbmPageVO.class);
            for(PrvoincePhbmPageVO pageVO:mapList){
                StringBuffer sb=new StringBuffer();
                String phbm=bizRespUserService.findByPhbmName(pageVO.getCityPhbm(),pageVO.getShiAreaCode());
                String qtbm=bizRespUserService.findByQtbmName(pageVO.getCityQtbm(), pageVO.getShiAreaCode());
                List<String> shiAreaCode=new ArrayList();
                shiAreaCode.add(pageVO.getAreaCode());
                String cityName=bizRespUserService.getCity(shiAreaCode);
                pageVO.setAreaCodeName(cityName);
                pageVO.setCityPhbm(phbm);
                pageVO.setCityQtbm(qtbm);

                //市级评分
                String citpMap=getCitpMap(pageVO);
                if(StringUtils.isNotEmpty(citpMap)){
                    citpMap= citpMap.substring(0, citpMap.length() - 1);
                    sb.append("单位自评").append("（").append(citpMap).append("）");
                }
                //查询省级平时评分
                String provincePsMap=getProvincePs(pageVO);
                if(StringUtils.isNotEmpty(provincePsMap)){
                    provincePsMap=provincePsMap.substring(0,provincePsMap.length() - 1);
                    sb.append("*平时监控").append("（").append(provincePsMap).append("）");
                }
                //查询省级年终评分
                String provinceNjMap = getProvinceNj(pageVO);
                if(StringUtils.isNotEmpty(provinceNjMap)){
                    provinceNjMap=  provinceNjMap.substring(0,provinceNjMap.length() - 1);
                    sb.append("*年终打分").append("（").append(provinceNjMap).append("）");
                }
                if(sb.length()>0){
                    pageVO.setIfTb("no");
                    sb.append("*未上报数据，不可评分！");
                }else{
                    pageVO.setIfTb("yes");
                }
                pageVO.setMessage(sb.toString());
            }
            map.put("list", mapList);
        }
        return map;
    }

    /**
     * 查询省级年终评分
     * @param pageVO
     * @return
     */
    private String getProvinceNj(PrvoincePhbmPageVO pageVO) {
        StringBuffer sb=new StringBuffer();
        List<String> phbmList=(List<String>) pageVO.getProvinceNjMap().get("phbmList");
        if(phbmList.size()>0){
            sb.append("配合部门").append("：");
            String deptName=bizRespUserService.getDept(phbmList,pageVO.getShiAreaCode());
            sb.append(deptName).append("；");
        }
        return sb.toString();
    }

    /**
     * 查询省级平时评分
     * @param pageVO
     * @return
     */
    private String getProvincePs(PrvoincePhbmPageVO pageVO) {
        StringBuffer sb=new StringBuffer();
        List<String> phbmList=(List<String>) pageVO.getProvincePsMap().get("phbmList");
        List<String> qtbmList=(List<String>) pageVO.getProvincePsMap().get("qtbmList");
        if(phbmList.size()>0){
            sb.append("配合部门").append("：");
            String deptName=bizRespUserService.getDept(phbmList,pageVO.getShiAreaCode());
            sb.append(deptName).append("；");
        }

        if(qtbmList.size()>0){
            sb.append("牵头部门").append("：");
            String deptName=bizRespUserService.getDept(qtbmList,pageVO.getShiAreaCode());
            sb.append(deptName).append("；");
        }
        return sb.toString();
    }

    /**
     * 市级评分
     * @param pageVO
     * @return
     */
    private String getCitpMap(PrvoincePhbmPageVO pageVO) {
        StringBuffer sb=new StringBuffer();
        List<String> phbmList=(List<String>) pageVO.getCityMap().get("phbmList");
        List<String> qtbmList=(List<String>) pageVO.getCityMap().get("qtbmList");
        if(phbmList.size()>0){
            sb.append("配合部门").append("：");
            String deptName=bizRespUserService.getDept(phbmList, pageVO.getAreaCode());
            sb.append(deptName).append("；");
        }

        if(qtbmList.size()>0){
            sb.append("牵头部门").append("：");
            String deptName=bizRespUserService.getDept(qtbmList,pageVO.getAreaCode());
            sb.append(deptName).append("；");
        }
        return sb.toString();
    }


    /**
     * 粮食安全行政首长责任制----省级牵头部门----查看
     * @param id
     * @return
     */
    @Override
    public CityTaskVO findById(String id) {
        CityTaskVO cityTaskVO=new CityTaskVO();
        ResponseWrapper responseWrapper=bizRespProvinceQtbmClient.findById(id);
        String dataJson= (String) responseWrapper.getData();
        //市牵头部门数据
        QtbmVO qtbmVO= JSON.parseObject(dataJson, QtbmVO.class);
        String qtbm=bizRespUserService.findByQtbmName(qtbmVO.getQtbm(), qtbmVO.getCityAreacode());
        qtbmVO.setQtbm(qtbm);
        String areaeCodeType=bizRespUserService.getAreaCodeType(qtbmVO.getAreaCode());
        // fnyq  非农业区 nyq 农业区
        qtbmVO.setAreaCodeType(areaeCodeType);
        if(StringUtils.isNotEmpty(qtbmVO.getFileId())){
            //上传文件的信息
            List<FileVO> fileVOList=bizRespFileService.getFileInfo(qtbmVO.getFileId());
            String fileName=fileVOList.get(0).getFileName();
            qtbmVO.setFileName(fileName);
        }



        //考核任务明细
        TaskInfoVO taskInfoVO=bizRespExaminationTaskService.findByTaskInfo(qtbmVO.getBizResexaminationTaskId());
        cityTaskVO.setQtbmVO(qtbmVO);
        cityTaskVO.setTaskInfo(taskInfoVO);

        if("60".equals(qtbmVO.getType())){
            String type="70";
            String taskId=qtbmVO.getBizResexaminationTaskId();
            String areacode=CurrentUtil.getAreaCode();
            ResponseWrapper responseWrappert=bizRespProvinceQtbmClient.selectByEntity(taskId, type,areacode);
            String phbmJson= (String) responseWrappert.getData();
            List<PhbmVO> phmbList= JSON.parseArray(phbmJson, PhbmVO.class);
            //抽查市配合部门数据
            for(PhbmVO phbmVO:phmbList){
                String ph =bizRespUserService.findByPhbmName(phbmVO.getPhbm(), qtbmVO.getCityAreacode());
                phbmVO.setPhbm(ph);
                if(StringUtils.isNotEmpty(phbmVO.getFileId())){
                    //上传文件的信息
                    List<FileVO> fileVOList=bizRespFileService.getFileInfo(phbmVO.getFileId());
                    String fileName=fileVOList.get(0).getFileName();
                    phbmVO.setFileName(fileName);
                }
            }
            cityTaskVO.setPhbmVOList(phmbList);
        }



        if("20".equals(qtbmVO.getType())){
            //查询市配合部门数据
            String type="10";
            String taskId=qtbmVO.getBizResexaminationTaskId();
            String areaCode=qtbmVO.getAreaCode();
            ResponseWrapper responseWrappert=bizRespProvinceQtbmClient.findByPhbmList(taskId, type);
            String phbmJson= (String) responseWrappert.getData();
            List<PhbmVO> phmbList= JSON.parseArray(phbmJson, PhbmVO.class);
            List<PhbmVO> cityPhmbList=new ArrayList();
            for(PhbmVO phbmVO:phmbList){
                if(phbmVO.getAreaCode().equals(qtbmVO.getAreaCode())){
                    String ph =bizRespUserService.findByPhbmName(phbmVO.getPhbm(), qtbmVO.getCityAreacode());
                    phbmVO.setPhbm(ph);
                    if(StringUtils.isNotEmpty(phbmVO.getFileId())){
                        //上传文件的信息
                        List<FileVO> fileVOList=bizRespFileService.getFileInfo(phbmVO.getFileId());
                        String fileName=fileVOList.get(0).getFileName();
                        phbmVO.setFileName(fileName);
                    }
                    cityPhmbList.add(phbmVO);
                }
            }
            cityTaskVO.setPhbmVOList(cityPhmbList);
        }
        return cityTaskVO;
    }


    /**
     * 粮食安全行政首长责任制----省级牵头部门---编辑
     * @param qtbmVO
     * @return
     */
    @Override
    public ResponseWrapper update(QtbmVO qtbmVO) {
        QtbmUpdateVO qtbmUpdateVO=new QtbmUpdateVO();
        qtbmUpdateVO.setQtbmVO(qtbmVO);
        qtbmUpdateVO.setUpdateBy(CurrentUtil.getUserName());
       return bizRespProvinceQtbmClient.update(qtbmUpdateVO);
    }


    /**
     * 粮食安全行政首长责任制----省级牵头部门---上报
     * @param id
     * @return
     */
    @Override
    public ResponseWrapper publish(String  id) {
        ProvincePhbmPublishVO phbmPublishVO=new ProvincePhbmPublishVO();
        phbmPublishVO.setId(id);
        phbmPublishVO.setDeptId(CurrentUtil.getDeptId());
        phbmPublishVO.setUpdateBy(CurrentUtil.getUserName());
        return  bizRespProvinceQtbmClient.publish(phbmPublishVO);
    }


    /**
     * 粮食安全行政首长责任制----省级牵头部门---批量上报
     * @param year
     * @return
     */
    @Override
    public ResponseWrapper publishALL( ProvincePhbmPublishVO phbmPublishVO) {
//        ProvincePhbmPublishVO phbmPublishVO=new ProvincePhbmPublishVO();
//        phbmPublishVO.setYear(year);
//        /**
//         * 类型  20 省级牵头部门  60 省级牵头部门时
//         */
//        phbmPublishVO.setType(type);
        /**
         * 状态：10 未录入 20 已录入  30 已上报
         */
        phbmPublishVO.setStatus("20");
        phbmPublishVO.setDeptId(CurrentUtil.getDeptId());
        phbmPublishVO.setUpdateBy(CurrentUtil.getUserName());
        return  bizRespProvinceQtbmClient.publishALL(phbmPublishVO);
    }
}