package com.unis.app.service.Impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.unis.accountability.businessmanagement.client.BizRespProvinceTaskClient;
import com.unis.accountability.businessmanagement.common.vo.backlog.ReceiverCollectionVO;
import com.unis.accountability.businessmanagement.common.vo.cityPhbm.PhbmVO;
import com.unis.accountability.businessmanagement.common.vo.provinceTask.ProvinceCityPageVO;
import com.unis.accountability.businessmanagement.common.vo.provinceTask.ProvinceCityTaskPage;
import com.unis.accountability.businessmanagement.common.vo.provinceTask.ProvinceTaskPage;
import com.unis.accountability.businessmanagement.common.vo.provinceTask.ProvinceTaskVO;
import com.unis.app.config.MyUserClient;
import com.unis.app.service.BizRespProvinceTaskService;
import com.unis.app.service.BizRespUserService;
import com.unis.common.utils.CurrentUtil;
import com.unis.common.utils.JsonUtils;
import com.unis.common.utils.ResponseWrapper;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.ObjectUtils;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/9/23 0023 17:31
 * @Description:
 */
@Service
public class BizRespProvinceTaskServiceImpl implements BizRespProvinceTaskService {
    @Autowired
    private BizRespProvinceTaskClient bizRespProvinceTaskClient;
    @Autowired
    private BizRespUserService bizRespUserService;
    @Autowired
    private MyUserClient myUserClient;
    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)----分页
     * @param provinceTaskPage
     * @param page
     * @param size
     * @return
     */
    @Override
    public Map findByPage(ProvinceTaskPage provinceTaskPage, Integer page, Integer size) {
        ResponseWrapper responseWrapper=bizRespProvinceTaskClient.findByPage(provinceTaskPage, page, size);
        String dataJson= (String) responseWrapper.getData();
        Map map=JSON.parseObject(dataJson, Map.class);
        String listJson=JSON.toJSONString(map.get("list"));
        List<Map> mapList= JSON.parseArray(listJson, Map.class);
        List<Map> mapList1 = new ArrayList<>();
        for(Map pageVO:mapList){
            String areaCode=pageVO.get("areacode").toString();
            pageVO.put("areaCode", areaCode);
            String areaCodeType=bizRespUserService.getAreaCodeType(areaCode);
            pageVO.put("areaCodeType", areaCodeType);
            List<String> shiAreaCode=new ArrayList();
            shiAreaCode.add(areaCode);
            String areaCodeName=bizRespUserService.getCity(shiAreaCode);
            pageVO.put("areaCodeName", areaCodeName);
            if(null != provinceTaskPage.getAreaCodeType() && !"".equals(provinceTaskPage.getAreaCodeType())){
                if (pageVO.get("areaCodeType").equals(provinceTaskPage.getAreaCodeType())){
                    mapList1.add(pageVO);
                }
            }else {
                mapList1 = mapList;
            }
        }
        map.put("list",mapList1);
        return map;

    }

    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)----州市考核明细
     * @param provinceCityTaskPage
     * @param page
     * @param size
     * @return
     */
    @Override
    public Map findCityByPage(ProvinceCityTaskPage provinceCityTaskPage, Integer page, Integer size) {
        ResponseWrapper responseWrapper=bizRespProvinceTaskClient.findCityByPage(provinceCityTaskPage, page, size);
        String dataJson= (String) responseWrapper.getData();
        Map map= JSON.parseObject(dataJson, Map.class);
        if(map!=null){
            String listJson=JSON.toJSONString(map.get("list"));
            List<ProvinceCityPageVO> mapList= JSON.parseArray(listJson, ProvinceCityPageVO.class);
            for(ProvinceCityPageVO pageVO:mapList){
                String cityZpbm=bizRespUserService.findByZpbmName(pageVO.getCityZpbm(),pageVO.getCityOrgId());
                pageVO.setCityZpbm(cityZpbm);
                String cityQtbm=bizRespUserService.findByPhbmName(pageVO.getCityPhbm(), pageVO.getCityOrgId());
                pageVO.setCityQtbm(cityQtbm);
                String cityPhbm=bizRespUserService.findByPhbmName(pageVO.getCityPhbm(), pageVO.getCityOrgId());
                pageVO.setCityPhbm(cityPhbm);
                String prvoinceQtbm=bizRespUserService.findByPhbmName(pageVO.getProvinceQtbm(), pageVO.getProvinceOrgId());
                pageVO.setProvinceQtbm(prvoinceQtbm);
                String prvoincePhbm=bizRespUserService.findByPhbmName(pageVO.getProvincePhbm(), pageVO.getProvinceOrgId());
                pageVO.setProvincePhbm(prvoincePhbm);

            }
            map.put("list", mapList);
        }
        return map;
    }

    /**
     * 粮食安全行政首长责任制----结果汇总查看（市局)----分页
     * @param provinceTaskPage
     * @param page
     * @param size
     * @return
     */
    @Override
    public Map findByHzPage(ProvinceTaskPage provinceTaskPage, Integer page, Integer size) {
        ResponseWrapper responseWrapper=bizRespProvinceTaskClient.findByHzPage(provinceTaskPage, page, size);
        String dataJson= (String) responseWrapper.getData();
        Map map=JSON.parseObject(dataJson, Map.class);
        String listJson=JSON.toJSONString(map.get("list"));
        List<Map> mapList= JSON.parseArray(listJson, Map.class);
        List<Map> mapList1 = new ArrayList<>();
        for(Map pageVO:mapList){
            String areaCode=pageVO.get("areacode").toString();
            pageVO.put("areaCode", areaCode);
            String areaCodeType=bizRespUserService.getAreaCodeType(areaCode);
            pageVO.put("areaCodeType", areaCodeType);
            List<String> shiAreaCode=new ArrayList();
            shiAreaCode.add(areaCode);
            String areaCodeName=bizRespUserService.getCity(shiAreaCode);
            pageVO.put("areaCodeName", areaCodeName);
            if(null != provinceTaskPage.getAreaCodeType()&& !"".equals(provinceTaskPage.getAreaCodeType())){
                if (pageVO.get("areaCodeType").equals(provinceTaskPage.getAreaCodeType())){
                    mapList1.add(pageVO);
                }
            }else {
                mapList1 = mapList;
            }

        }
        map.put("list",mapList1);
        return map;
    }

    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)---驳回
     * @param taskId
     * @return
     */
    @Override
    public ResponseWrapper saveReappraisal(String taskId,String shiAreaCode) {
        return bizRespProvinceTaskClient.saveReappraisal(taskId,shiAreaCode);

    }

    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)---省级配合部门和牵头部门评价明细
     * @param taskId
     * @param shiAreaCode
     * @return
     */
    @Override
    public ProvinceTaskVO findByProvinceQtbmAndPhbm(String taskId, String shiAreaCode) {
        ResponseWrapper responseWrapper=bizRespProvinceTaskClient.findByProvinceQtbmAndPhbm(taskId,shiAreaCode);
        String dataJson= (String) responseWrapper.getData();
        ProvinceTaskVO provinceTaskVO= JSON.parseObject(dataJson, ProvinceTaskVO.class);
        for(PhbmVO phbmVO:provinceTaskVO.getPhbmVOList()){
            String prvoincePhbm=bizRespUserService.findByPhbmName(phbmVO.getPhbm(), phbmVO.getOrgId());
            phbmVO.setPhbm(prvoincePhbm);
        }

        for(PhbmVO phbmpsVO:provinceTaskVO.getPhbmPsVOList()){
            String prvoincePhbm=bizRespUserService.findByPhbmName(phbmpsVO.getPhbm(), phbmpsVO.getOrgId());
            phbmpsVO.setPhbm(prvoincePhbm);
        }
        String prvoinceQtbm=bizRespUserService.findByPhbmName(provinceTaskVO.getQtbm().getQtbm(),provinceTaskVO.getQtbm().getOrgId());
        provinceTaskVO.getQtbm().setQtbm(prvoinceQtbm);
        String prvoincepsQtbm=bizRespUserService.findByPhbmName(provinceTaskVO.getQtbmPs().getQtbm(),provinceTaskVO.getQtbmPs().getOrgId());
        provinceTaskVO.getQtbmPs().setQtbm(prvoincepsQtbm);

        return  provinceTaskVO;
    }

    /***
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)---提交
     * @param provinceCityTaskPage
     * @return
     */
    @Override
    public ResponseWrapper publish(ProvinceCityTaskPage provinceCityTaskPage) {
        return bizRespProvinceTaskClient.publish(provinceCityTaskPage);

    }

    /**
     * 粮食安全行政首长责任制----考核结果查看（市局)---抽查分发
     * @param provinceCityTaskPage
     * @return
     */
    @Override
    public ResponseWrapper publishCcFf(List<ProvinceCityTaskPage>  provinceCityTaskPage) {
        for(ProvinceCityTaskPage cityTaskPage:provinceCityTaskPage){
            cityTaskPage.setUserName(CurrentUtil.getUserName());
            cityTaskPage.setUserId(CurrentUtil.getUserId());
            cityTaskPage.setOrgName(CurrentUtil.getOrgName());
            List<ReceiverCollectionVO> userList = new ArrayList<>();
            //获取区粮办所有人
            List<Map> mapList=bizRespUserService.findDataShiTree();
            if(CollectionUtils.isEmpty(mapList)) {
                return ResponseWrapper.error( 500, "获取区粮办信息失败！" ,null);
            }
            List<String> areaCodeList=new ArrayList();
            areaCodeList.add(cityTaskPage.getAreaCode());
            //市抽查--cbl
            ResponseWrapper wrapper = myUserClient.findUserByAreaCode(areaCodeList);
            if (wrapper.isSuccess() && !ObjectUtils.isEmpty(wrapper.getData())) {
                JSONArray objArr = JSON.parseArray(JsonUtils.serialize(wrapper.getData()));
                if (!ObjectUtils.isEmpty(objArr)) {
                    for(int i=0;i<objArr.size();i++) {
                       // System.out.println(.get("id"));
                        ReceiverCollectionVO receiverCollectionVO = new ReceiverCollectionVO();
                        receiverCollectionVO.setUserId(objArr.getJSONObject(i).getString("userCode"));
                        receiverCollectionVO.setUserName(objArr.getJSONObject(i).getString("userName"));
                        userList.add(receiverCollectionVO);
                    }
                   /* objArr.forEach(jsonObj -> {
                        JSONObject obj = (JSONObject) jsonObj;

                    });*/
                }
            }
            cityTaskPage.setUserList(userList);
        }
        return bizRespProvinceTaskClient.publishCcFf(provinceCityTaskPage);
    }


}