package com.unis.app.service.Impl;

import com.alibaba.fastjson.JSON;
import com.unis.accountability.businessmanagement.client.BizRespScoreInputClient;
import com.unis.accountability.businessmanagement.common.vo.cityQtbm.CityTaskinfoVO;
import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskPublishVO;
import com.unis.accountability.businessmanagement.common.vo.examinationTask.BizRespExaminationTaskVO;
import com.unis.accountability.businessmanagement.common.vo.examinationTask.TaskInfoVO;
import com.unis.accountability.businessmanagement.common.vo.respScoreInput.BizRespRespScoreInputPublishVO;
import com.unis.accountability.businessmanagement.common.vo.respScoreInput.BizRespScoreInputSmiitVO;
import com.unis.accountability.businessmanagement.common.vo.respScoreInput.BizRespScoreInputVO;
import com.unis.accountability.businessmanagement.common.vo.responsibility.BizRespResponsibilityPageVO;
import com.unis.app.service.*;
import com.unis.common.utils.CurrentUtil;
import com.unis.common.utils.ResponseWrapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Auther:张新亮
 * @Date: 2019/9/19 0019 15:44
 * @Description:
 */
@Service
public class BizRespScoreInputServiceImpl implements BizRespScoreInputService {
    @Autowired
    private BizRespScoreInputClient bizRespScoreInputClient;
    @Autowired
    private BizRespExaminationTaskService bizRespExaminationTaskService;
    @Autowired
    private BizRespCityZpbmService bizRespCityZpbmService;
    @Autowired
    private BizRespCityQtbmService bizRespCityQtbmService;
    @Autowired
    private BizRespUserService bizRespUserService;
    /**
     * 粮食安全首长责任制--州市考核任务管理----发布
     * @param id
     */
    @Override
    public void publish(String id) {
        BizRespRespScoreInputPublishVO inputPublishVO=new BizRespRespScoreInputPublishVO();
        inputPublishVO.setId(id);
        inputPublishVO.setUpdateBy(CurrentUtil.getUserName());
        bizRespScoreInputClient.publish(inputPublishVO);
    }

    /**
     * 粮食安全首长责任制--州市考核任务管理  根据年分 状态 行政区划 查询 州市考核录入数据
     * @param cityTaskPublishVO
     * @return
     */
    @Override
    public List<BizRespScoreInputVO> findByYearAndStatusAndAreaCode(CityTaskPublishVO cityTaskPublishVO) {
        ResponseWrapper responseWrapper=bizRespScoreInputClient.findByYearAndStatusAndAreaCode(cityTaskPublishVO);
        String dataJson= (String) responseWrapper.getData();
        List<BizRespScoreInputVO> mapList= JSON.parseArray(dataJson, BizRespScoreInputVO.class);
        return mapList;
    }

    /**
     * 粮食安全首长责任制--下发州市考核任务----制定州市考核任务--- 分页
     * @param bizRespResponsibilityPageVO
     * @param page
     * @param size
     * @return
     */
    @Override
    public ResponseWrapper findByPage(BizRespResponsibilityPageVO bizRespResponsibilityPageVO, Integer page, Integer size) {
        bizRespResponsibilityPageVO.setAreaCode(CurrentUtil.getAreaCode());
        ResponseWrapper responseWrapper=bizRespScoreInputClient.findTaskByPage(bizRespResponsibilityPageVO, page, size);
        return responseWrapper;
    }

    /**
     * 粮食安全行政首长责任制----市级配合部门 牵头部门 自评部门----查看
     * @param taskId
     * @param areaCode
     * @return
     */
    @Override
    public CityTaskinfoVO findByQtbmAndPhbmAndZpbm(String taskId, String areaCode) {
        CityTaskinfoVO cityTaskinfoVO=bizRespCityQtbmService.findByTaskIdAndAreaCode(taskId,areaCode);
        TaskInfoVO taskInfoVO= bizRespExaminationTaskService.findByTaskInfo(taskId);
        cityTaskinfoVO.setTaskInfoVO(taskInfoVO);
        return cityTaskinfoVO;
    }

    /**
     * 州市、外部单位牵头部门、配合部门评分--查询是否可以提交数据d
     * @return
     */
    @Override
    public ResponseWrapper findByIsSubmit(BizRespScoreInputSmiitVO scoreInputSmiitVO) {
        scoreInputSmiitVO.setDeptId(CurrentUtil.getOrgId());
        if("80".equals(scoreInputSmiitVO.getType())){
            scoreInputSmiitVO.setAreaCode(CurrentUtil.getAreaCode());
        }
        return bizRespScoreInputClient.findByIsSubmit(scoreInputSmiitVO);
    }
    /**
     * 粮食安全行政首长责任制----评分表分处室考核（市部门）----查看
     * @param id
     * @return
     */
    @Override
    public BizRespExaminationTaskVO findByInputId(String id) {
        ResponseWrapper responseWrapper = bizRespScoreInputClient.findByInputId(id);
        String dataJson= (String) responseWrapper.getData();
        BizRespExaminationTaskVO bizRespExaminationTaskVO= JSON.parseObject(dataJson, BizRespExaminationTaskVO.class);
        String phbm = bizRespUserService.findByPhbmName(bizRespExaminationTaskVO.getCoordinationDepartment(),bizRespExaminationTaskVO.getAreaCode());
        String qtbm = bizRespUserService.findByQtbmName(bizRespExaminationTaskVO.getLeadDepartment(), bizRespExaminationTaskVO.getAreaCode());
        bizRespExaminationTaskVO.setPhbmName(phbm);
        bizRespExaminationTaskVO.setQtbmName(qtbm);
        return bizRespExaminationTaskVO;
    }
}