package com.unis.app.service.Impl;

import com.unis.accountability.businessmanagement.client.BizRespScoringCityClient;
import com.unis.accountability.businessmanagement.common.vo.scoringCity.BizRespScoringCityPublishVO;
import com.unis.accountability.businessmanagement.common.vo.scoringCity.CityVO;
import com.unis.accountability.businessmanagement.common.vo.scoringCity.ScoringCityUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.scoringCity.ScoringPage;
import com.unis.app.service.BizRespScoringCityService;
import com.unis.common.utils.CurrentUtil;
import com.unis.common.utils.ResponseWrapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Auther:张新亮
 * @Date: 2019/9/19 0019 19:23
 * @Description:
 */
@Service
public class BizRespScoringCityServiceImpl implements BizRespScoringCityService {

    @Autowired
    private BizRespScoringCityClient bizRespScoringCityClient;

    /**
     * 粮食安全首长责任制--州市任务填报设置----分页
     * @param scoringPage
     * @param page
     * @param size
     * @return
     */
    @Override
    public ResponseWrapper findByPage(ScoringPage scoringPage, Integer page, Integer size) {
        scoringPage.setAreaCode(CurrentUtil.getAreaCode());
        ResponseWrapper responseWrapper= bizRespScoringCityClient.findByPage(scoringPage, page, size);
        return responseWrapper;

    }

    /**
     * 粮食安全首长责任制--州市任务填报设置----查看
     * @param id
     * @return
     */
    @Override
    public ResponseWrapper findById(String id) {
        return bizRespScoringCityClient.findById(id);
    }

    /**
     * 粮食安全首长责任制--州市任务填报设置---编辑
     * @param cityVO
     * @return
     */
    @Override
    public ResponseWrapper update(CityVO cityVO) {
        ScoringCityUpdateVO scoringCityUpdateVO=new ScoringCityUpdateVO();
        scoringCityUpdateVO.setUpdateBy(CurrentUtil.getUserName());
        scoringCityUpdateVO.setCityVO(cityVO);
        scoringCityUpdateVO.setOrgId(CurrentUtil.getOrgId());
        scoringCityUpdateVO.setDeptId(CurrentUtil.getDeptId());
        return bizRespScoringCityClient.update(scoringCityUpdateVO);

    }

    /**
     * 粮食安全首长责任制--州市考核任务管理----发布
     * @param id
     * @return
     */
    @Override
    public ResponseWrapper publish(String  id) {
        BizRespScoringCityPublishVO publishVO=new BizRespScoringCityPublishVO();
        publishVO.setUpdateBy(CurrentUtil.getUserName());
        publishVO.setId(id);
        return bizRespScoringCityClient.publish(publishVO);
    }

    /**
     * 粮食安全首长责任制--州市任务填报设置----根据年分查询明细
     * @param year
     * @return
     */
    @Override
    public ResponseWrapper findByYear(String year) {
        String orgId=CurrentUtil.getOrgId();
        return bizRespScoringCityClient.findByYearAndOrgId(year,orgId);

    }

    /**
     * 粮食安全首长责任制--州市任务填报设置----根据年分和状态---考核评分权重--对象
     * @param year
     * @param status
     * @return
     */
    @Override
    public ResponseWrapper findByYearAndStatus(String year, String status) {
        String areaCode=CurrentUtil.getAreaCode();
        System.out.println("areaCode=="+areaCode);
        return bizRespScoringCityClient.findByYearAndStatus(year, status,areaCode);
    }
}