package com.unis.app.service.Impl;

import com.unis.accountability.businessmanagement.client.BizRespScoringWeightClient;
import com.unis.accountability.businessmanagement.common.vo.DeleteVO;
import com.unis.accountability.businessmanagement.common.vo.scoringWeight.*;
import com.unis.app.service.BizRespScoringWeightService;
import com.unis.common.utils.CurrentUtil;
import com.unis.common.utils.ResponseWrapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**粮食安全行政首长责任制-----省级任务填报设置
 * @Auther:张新亮
 * @Date: 2019/9/17 0017 18:24
 * @Description:
 */
@Service
public class BizRespScoringWeightServiceImpl implements BizRespScoringWeightService {

    @Autowired
    private BizRespScoringWeightClient bizRespScoringWeightClient;

    /**
     *  考核评分权重--考核等级设置
     * @param id
     * @return
     */
    @Override
    public ResponseWrapper findByWeightRank(String type, String id) {
       return bizRespScoringWeightClient.findByWeightRank(type,id);
    }


    /**
     *  考核评分权重--考核等级设置
     * @param type
     * @return
     */
    @Override
    public ResponseWrapper findByYear(String type) {
        return bizRespScoringWeightClient.findByYear(type);
    }

    /**
     * 考核评分权重--查询复制评分表可选年分
     * @param year
     * @return
     */
    @Override
    public ResponseWrapper findByCopyYear() {
        return bizRespScoringWeightClient.findByCopyYear();
    }


    /**
     * 考核评分权重--考核等级设置
     * @param year
     * @param status
     * @return
     */
    @Override
    public ResponseWrapper findByYearAndStatus(Integer year, Integer status) {
        return bizRespScoringWeightClient.findByYearAndStatus(year,status);
    }


    /**
     * 核评分权重----保存
     */
    @Override
    public ResponseWrapper save(WeightVO weightVO) {
        WeightSaveVO weightSaveVO=new WeightSaveVO();
        //创建人
        weightSaveVO.setCreateBy(CurrentUtil.getUserName());
        //行政区划
        weightSaveVO.setAreaCode(CurrentUtil.getAreaCode());
        //部门ID
        weightSaveVO.setDeptId(CurrentUtil.getDeptId());
        //部门ID
        weightSaveVO.setOrgId(CurrentUtil.getOrgId());
        weightSaveVO.setWeightVO(weightVO);
        return bizRespScoringWeightClient.save(weightSaveVO);
    }

    /**
     * 核评分权重----分页
     * @param pageVO
     * @param page
     * @param size
     * @return
     */
    @Override
    public ResponseWrapper findByPage(BizRespScoringWeightPageVO pageVO, Integer page, Integer size) {
        pageVO.setAreaCode(CurrentUtil.getAreaCode());
        return bizRespScoringWeightClient.findByPage(pageVO,page,size);
    }

    /**
     *  考核评分权重--考核等级设置
     * @param id
     * @return
     */
    @Override
    public ResponseWrapper findById(String id) {
        return bizRespScoringWeightClient.findById(id);
    }

    /**
     * 核评分权重---修改
     */
    @Override
    public ResponseWrapper update(WeightVO weightVO) {
        WeightUpdateVO weightUpdateVO=new WeightUpdateVO();
        //创建人
        weightUpdateVO.setUpdateBy(CurrentUtil.getUserName());
        weightUpdateVO.setWeightVO(weightVO);
        return bizRespScoringWeightClient.update(weightUpdateVO);
    }

    /**
     * 核评分权重---发布
     */
    @Override
    public ResponseWrapper publish(String id) {
        BizRespScoringWeightPublishVO weightPublishVO=new BizRespScoringWeightPublishVO();
        //创建人
        weightPublishVO.setUpdateBy(CurrentUtil.getUserName());
        weightPublishVO.setId(id);
        return bizRespScoringWeightClient.publish(weightPublishVO);
    }

    /**
     * 核评分权重---删除
     */
    @Override
    public ResponseWrapper deletes(String id ) {
        DeleteVO deleteVO=new DeleteVO();
        deleteVO.setId(id);
        deleteVO.setDeleteBy(CurrentUtil.getUserName());
        return bizRespScoringWeightClient.delete(deleteVO);
    }
}