package com.unis.app.service.Impl;

import com.alibaba.fastjson.JSON;
import com.github.pagehelper.util.StringUtil;
import com.unis.accountability.businessmanagement.common.vo.cityFf.UserDTO;
import com.unis.accountability.businessmanagement.common.vo.msgNotice.DepartmentDTO;
import com.unis.accountability.businessmanagement.common.vo.msgNotice.OrgainzeDTO;
import com.unis.app.config.DataDictClient;
import com.unis.app.config.MyUserClient;
import com.unis.app.service.BizRespUserService;
import com.unis.common.utils.CurrentUtil;
import com.unis.common.utils.ResponseWrapper;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.compress.utils.Lists;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.ObjectUtils;

import java.util.*;

/**
 * @Auther:张新亮
 * @Date: 2019/9/19 0019 14:03
 * @Description:
 */
@Slf4j
@Service
public class BizRespUserServiceImpl implements BizRespUserService {

    @Autowired
    private MyUserClient myUserClient;
    @Autowired
    private DataDictClient dataDictClient;

    private static String type="10190008";
    //市级
    private static String cityCode="LS002001";
    //区级
    private static String quCode="LS002002";
    /**
     * 粮食安全省长责任制--省市单位和外部部门 -----查询所有部门
     * @param code
     * @return
     */
    @Override
    public List<Map> findByQtbmAndPhbm(String areaCode) {
        List<Map> qbbmList=new ArrayList();
        ResponseWrapper responseWrapper= myUserClient.findByAreaCodeAndOrgType(areaCode, type);
        if(responseWrapper.getInfoCode()==200){
            List<Map> mapList= (List<Map>) responseWrapper.getData();
            String parentCode="";
            if("120000".equals(areaCode)){
                parentCode=cityCode;
                 qbbmList=getWbbmList(mapList,parentCode);
            }else{
                parentCode=quCode;
                qbbmList=getQubmList(mapList, parentCode);
            }

            return qbbmList;
        }

        return null;
    }

    private List<Map> getQubmList(List<Map> mapList, String parentCode) {
        List<Map> wbdwList=new ArrayList();
        for(Map map:mapList){
            Map map1=new HashMap();
            String deptCode= map.get("orgCode").toString();
            String deptName= map.get("orgName").toString();
            String parCode=map.get("parentCode")==null?"":map.get("parentCode").toString();
            map1.put("id",deptCode);
            map1.put("name",deptName);
            map1.put("parCode",parCode);
            wbdwList.add(map1);
//            String parCode=map.get("parentCode")==null?"":map.get("parentCode").toString();
//            if(!parCode.equals(parentCode)){
//                Map map1=new HashMap();
//                String deptCode= map.get("orgCode").toString();
//                String deptName= map.get("orgName").toString();
//                map1.put("id",deptCode);
//                map1.put("name",deptName);
//                wbdwList.add(map1);
//            }
        }
        
        //删除自己区名称
        wbdwList.remove(0);
        return wbdwList;
    }


    private Map getAreaOrgList(List<Map> mapList, String parentCode) {
        List<Map> wbdwList=new ArrayList();
        for(Map map:mapList){
            Map map1=new HashMap();
            String deptCode= map.get("orgCode").toString();
            String deptName= map.get("orgName").toString();
            map1.put("id",deptCode);
            map1.put("name",deptName);
            wbdwList.add(map1);
//            String parCode=map.get("parentCode")==null?"":map.get("parentCode").toString();
//            if(!parCode.equals(parentCode)){
//                Map map1=new HashMap();
//                String deptCode= map.get("orgCode").toString();
//                String deptName= map.get("orgName").toString();
//                sjOrgId=deptCode;
//                map1.put("id",deptCode);
//                map1.put("name",deptName);
//                wbdwList.add(map1);
//            }
        }
        Map map=wbdwList.get(0);
        String id=map.get("id").toString();
        String name=map.get("name").toString();
        wbdwList.remove(0);
        
        Map area=new HashMap();
        area.put("id",id);
        area.put("name",name);
        area.put("orgList", wbdwList);
        return area;
    }



    /**
     * 粮食安全省长责任制--州市-----自评部门
     * @return
     */
    @Override
    public List<Map> findByZpbm(String orgId) {
        ResponseWrapper responseWrapper= myUserClient.findByOrgCode(orgId);
        if(responseWrapper.getInfoCode()==200){
            List<Map> mapList= (List<Map>) responseWrapper.getData();
            List<Map> qbbmList=getZpbmList(mapList);
            return qbbmList;
        }

        return null;
    }

    /**
     * 粮食安全省长责任制--获取所有省市
     * @return
     */
    @Override
    public List<Map> findDataShiTree() {
        List<Map> result=new ArrayList();
        ResponseWrapper  responseWrapper=dataDictClient.getDataTree();
        Object obj = responseWrapper.getData();
        if(ObjectUtils.isEmpty(obj)) {
        	return Lists.newArrayList();
        }
        List<Map> mapList= (List<Map>) obj;
        for(Map map:mapList){
            List<Map> shiList= (List<Map>) map.get("subDataDictionarys");
            if(shiList!=null&&shiList.size()>0){
                for(Map shi:shiList){
                    Map sh=new HashMap();
                    String shiname=shi.get("dictName").toString();
                    String shiareaCode=shi.get("dictCode").toString();
                    sh.put("orgName",shiname);
                    sh.put("areaCode",shiareaCode);
                    if("和平区".equals(shiname) || "河东区".equals(shiname)  || "河西区".equals(shiname)
                            || "南开区".equals(shiname) || "河北区".equals(shiname) || "红桥区".equals(shiname)
                            ){
                        sh.put("areaCodeType", "fnyq");
                    }else{
                        sh.put("areaCodeType","nyq");
                    }
                    result.add(sh);
                }
            }
        }
        System.out.println(result.toString());
        log.info(result.toString());
        return result;
    }



    /**
     * 自评部门
     * @param mapList
     * @return
     */
    private List<Map> getZpbmList(List<Map> mapList) {
        List<Map> wbdwList=new ArrayList();
        for(Map map:mapList){
            String orgType=map.get("orgType").toString();
            if("内设部门".equals(orgType)){
                List<Map> maps= (List<Map>) map.get("children");
                for(Map dept:maps){
                    Map map1=new HashMap();
                    String deptCode= dept.get("deptCode").toString();
                    String deptName= dept.get("deptName").toString();
                    map1.put("ID",deptCode);
                    map1.put("NAME",deptName);
                    wbdwList.add(map1);
                }
                return wbdwList;
            }
        }
        return null;

    }

    /**
     * 省市单位和外部部门
     * @param mapList
     * @param codeType
     * @return
     */
    private List<Map> getWbbmList(List<Map> mapList, String codeType) {
        List<Map> wbdwList=new ArrayList();
        for(Map map:mapList){
            String orgType=map.get("orgType")==null?"":map.get("orgType").toString();
            String parentCode=map.get("parentCode")==null?"":map.get("parentCode").toString();
            if(type.equals(orgType) && codeType.equals(parentCode)){
                Map map1=new HashMap();
                String deptCode= map.get("orgCode").toString();
                String deptName= map.get("orgName").toString();
                map1.put("id",deptCode);
                map1.put("name",deptName);
                
                if(deptName.contentEquals("测试02")) {
                	System.out.println(JSON.toJSONString(map));
                }
                wbdwList.add(map1);
            }
        }
        return wbdwList;
    }




    /**
     * 获取自评部门名字
     * @param zpbm
     * @return
     */
    @Override
    public String findByZpbmName(String zpbm,String orgId) {
        if(StringUtil.isNotEmpty(zpbm)){
            List<Map> mapList= this.findByZpbm(orgId);
            for(Map map:mapList){
                String deptCode=map.get("ID").toString();
                String deptName=map.get("NAME").toString();
                if(zpbm.equals(deptCode)){
                    return  deptName;
                }
            }
        }
        return null;

    }

    /**
     * 获取配合部门名字
     * @param phbm
     * @return
     */
    @Override
    public String findByPhbmName(String phbm,String orgId) {
        StringBuffer sb=new StringBuffer();
        if(StringUtil.isNotEmpty(phbm)){
            List<Map> mapList= this.findByQtbmAndPhbm(orgId);
            String[] phbmList =phbm.split(",");
            for(String ph:phbmList){
                for(Map map:mapList){
                    String deptCode=map.get("id").toString();
                    String deptName=map.get("name").toString();
                    if(ph.equals(deptCode)){
                        sb.append(deptName).append(",");
                    }
                }
            }
            return  deleteCharAt(sb);
        }
        return null;
    }

    /**
     * 获取牵头部门名字
     * @param qtbm
     * @return
     */
    @Override
    public String findByQtbmName(String qtbm,String orgId) {
        StringBuffer sb=new StringBuffer();
        if(StringUtil.isNotEmpty(qtbm)){
            List<Map> mapList= this.findByQtbmAndPhbm(orgId);
            String[] qtbmList =qtbm.split(",");
            for(String qt:qtbmList){
                for(Map map:mapList){
                    String deptCode=map.get("id").toString();
                    String deptName=map.get("name").toString();
                    if(qt.equals(deptCode)){
                        sb.append(deptName).append(",");
                    }
                }
            }
            return  deleteCharAt(sb);
        }
        return null;

    }

    /**
     * 删除最后一个字符
     * @param sb
     * @return
     */
    @Override
    public String deleteCharAt(StringBuffer sb) {
        if(sb.length()>1){
            sb.deleteCharAt(sb.length() - 1);
            return sb.toString();
        }
        return null;
    }

    /**
     * 行政区划转换
     * @param zhoushiList
     * @return
     */
    @Override
    public String getCity(List<String> zhoushiList) {
        StringBuffer result=new StringBuffer();
        if(zhoushiList!=null && zhoushiList.size()>0){
            //所有州椒
            List<Map>  unitList=this.findDataShiTree();
            for(String areaCode:zhoushiList){
                for(Map map:unitList){
                    String code=map.get("areaCode").toString();
                    String orgName=map.get("orgName").toString();
                    if(areaCode.equals(code)){
                        result.append(orgName).append(",");
                        break;
                    }
                }
            }
            String re= result.substring(0, result.length() - 1);
            return re;
        }
      return null;

    }


    /**
     * 粮食安全省长责任制--获取所有省市--农业区和非农业区
     * @return
     */
    @Override
    public Map findNyqAndFnyq() {
        List<Map> mapList=this.findDataShiTree();
        //非农业 和平区 河东区  河西区  南开区  河北区 红桥区
        List<Map> lscq=new ArrayList();
        List<Map> lsfcq=new ArrayList();

        for(Map map:mapList){
            String shiname=map.get("orgName").toString();
            if("呼和浩特市".equals(shiname) || "包头市".equals(shiname)  || "呼伦贝尔市".equals(shiname)
                    || "兴安盟".equals(shiname) || "通辽市".equals(shiname) || "赤峰市".equals(shiname)
                    || "乌兰察布市".equals(shiname) || "鄂尔多斯市".equals(shiname) || "巴彦淖尔市".equals(shiname)
                    ){
                lscq.add(map);
            }else{
                lsfcq.add(map);
            }
        }
        Map map=new HashMap();
        map.put("lscq",lscq);
        map.put("lsfcq",lsfcq);
        return map;
    }


    /**
     * 查询区划类型
     * @param areaCode
     * @return
     */
    @Override
    public String getAreaCodeType(String areaCode) {
        List<Map> mapList=this.findDataShiTree();
        for(Map map:mapList){
            String qAreaCode=map.get("areaCode").toString();
            String areaCodeType=map.get("areaCodeType").toString();
            if(qAreaCode.equals(areaCode)){
                return areaCodeType;
            }
        }
        return null;
    }

    /**
     * 粮食安全省长责任制--评分表分处室考核（市部门）--考核处室
     * @return
     */
    @Override
    public Set<Map> findByUserTree() {
        UserDTO userDTO=new UserDTO();
        userDTO.setOrgCode(CurrentUtil.getOrgId());
        Integer page=1;
        Integer size=1000;
        ResponseWrapper responseWrapper= myUserClient.findByDeptCode(userDTO,page,size);
        Map map= (Map) responseWrapper.getData();
        List<Map> mapList= (List<Map>) map.get("content");
        Set<Map> deptList=new HashSet();
        for(Map dept:mapList){
            String deptCode=dept.get("deptCode")==null?null:dept.get("deptCode").toString();
            String deptName=dept.get("deptName")==null?null:dept.get("deptName").toString();
            //  && deptCode.length()>5
//            if(StringUtil.isNotEmpty(deptCode) && StringUtil.isNotEmpty(deptName)  && deptCode.length()>5){
            if(StringUtil.isNotEmpty(deptCode) && StringUtil.isNotEmpty(deptName)){
                Map deptResult=new HashMap();
                deptResult.put("deptCode",deptCode);
                deptResult.put("deptName",deptName);
                deptList.add(deptResult);
            }
        }
        for(Map dept:deptList){
            String deptCode=dept.get("deptCode")==null?null:dept.get("deptCode").toString();
            List<Map> userList=new ArrayList();
            for(Map user:mapList){
                String userDeptCode=dept.get("deptCode")==null?null:user.get("deptCode").toString();
                if(deptCode.equals(userDeptCode)  && userDeptCode.length()>5){
                    Map userDept=new HashMap();
                    String userName=user.get("userName")==null?null:user.get("userName").toString();
                    String userLoginName=user.get("userLoginName")==null?null:user.get("userLoginName").toString();
                    String userCode=user.get("userCode")==null?null:user.get("userCode").toString();
                    userDept.put("deptName",userName+"--"+userLoginName) ;
                    userDept.put("deptCode",userCode) ;
                    userList.add(userDept);
                }
            }
            dept.put("userList",userList);
        }
        return deptList;
    }

    /**
     *  根据组织编号获取本单位名字
     * @param orgId
     * @return
     */
    @Override
    public String findByCode(String orgId) {
        ResponseWrapper responseWrapper= myUserClient.findByCode(orgId);
        String  result= (String) responseWrapper.getData();
        return result;
    }

    /**
     * 粮食安全省长责任制--省市单位和外部部门 -----组织机构树
     * @param orgCode
     * @return
     */
    @Override
    public List<Map> getAllOrgDescendantsTree(String orgCode) {
        List<Map> orgList=new ArrayList();
        ResponseWrapper responseWrapper= myUserClient.getAllOrgDescendantsTree(orgCode);
        Map  result= (Map) responseWrapper.getData();
        List<Map> mapList= (List<Map>) result.get("children");
        for(Map map:mapList){
            Map orgMap=new HashMap();
            String orgCod=map.get("orgCode").toString();
            String orgName=map.get("orgName").toString();
            orgMap.put("orgCode",orgCod);
            orgMap.put("orgName",orgName);
            orgList.add(orgMap);
        }
        return orgList;
    }




    /**
     * 粮食安全省长责任制--获取省市所有部门信息--非树
     * @return
     */
    @Override
    public List<Map> findByAllDept() {
        ResponseWrapper  responseWrapper=myUserClient.getAllDept();
        List<Map> mapList= (List<Map>) responseWrapper.getData();
        return mapList;
    }



    /**
     * 部门信息划转换
     * @param deptList
     * @return
     */
    @Override
    public String getDept(List<String> deptList,String areaCode) {
        StringBuffer result=new StringBuffer();
        if(deptList!=null && deptList.size()>0){
            //所有外部部门
             List<Map> unitList= this.findByQtbmAndPhbm(areaCode);
            for(String dept:deptList){
                for(Map map:unitList){
                    String code=map.get("id").toString();
                    String orgName=map.get("name").toString();
                    if(dept.equals(code)){
                        result.append(orgName).append(",");
                        break;
                    }
                }
            }
            if(StringUtils.isNotEmpty(result.toString())) {
            	return result.substring(0, result.length() - 1);
            }
        }
        return null;

    }


    /**
     * 粮食安全省长责任制--获取省市所有部门信息--树
     * @return
     */
    @Override
    public List<Map> findByDeptTree() {
        List<Map> deptList=new ArrayList();
        String areaCode=CurrentUtil.getAreaCode();
        if(areaCode.contains("0000")){
            //各市
            deptList=getDeptCity();
        }else{
            //省级
            areaCode=areaCode.substring(0,2)+"0000";
            System.out.println(areaCode);
            deptList=getDeptProvince(areaCode);
        }
        return deptList;
    }



    private List<Map> getDeptCity() {
        List<Map> mapList=new ArrayList();
        List<Map> areaCodeList=this.findDataShiTree();
        for(Map map:areaCodeList){
            String orgName=map.get("orgName").toString();
            String areaCode=map.get("areaCode").toString();
            //获取各市----内设部门
            List<Map> nsbmList=getDeptCode(areaCode);
            if(nsbmList!=null && nsbmList.size()>0 ){
                Map result=new HashMap();
                result.put("deptName",orgName);
                result.put("deptCode","DP001");
                result.put("nsbm",nsbmList);
                mapList.add(result);
            }
        }
        return mapList;

    }

    private List<Map> getDeptCode(String areaCode) {
        List<Map> mapList=new ArrayList();
        ResponseWrapper  responseWrapper=myUserClient.findByDepartmentAreaCode(areaCode);
        List<Map> deptList= (List<Map>) responseWrapper.getData();
        for(Map dept:deptList){
            String deptName=dept.get("deptName").toString();
            String deptCode=dept.get("deptCode").toString();
            if("内设部门".equals(deptName)){
                ResponseWrapper  responseWrapper1=myUserClient.getParentData(deptCode);
                List<Map> nsbmList= (List<Map>) responseWrapper1.getData();
                for(Map map1:nsbmList){
                    Map map=new HashMap();
                    deptName=map1.get("deptName").toString();
                    deptCode=map1.get("deptCode").toString();
                    map.put("deptName",deptName);
                    map.put("deptCode",deptCode);
                    mapList.add(map);
                }
                return mapList;
            }
        }
        return null;
    }


    /**
     * 省级内设置部门
     * @param areaCode
     * @return
     */
    private List<Map> getDeptProvince(String areaCode) {
        List<Map> mapList=new ArrayList();
        List<Map> nsbmList=  getDeptCode(areaCode);
        Map result=new HashMap();
        result.put("deptName", "天津市粮食和物资储备局");
        result.put("deptCode", "DP001");
        result.put("nsbm", nsbmList);
        mapList.add(result);
      return  mapList;
    }




    /**
     * 粮食安全行政首长责任制----部门用户管理 市区----保存
     * @param userDTO
     * @return
     */
    @Override
    public ResponseWrapper saveOrg(
            com.unis.accountability.businessmanagement.common.vo.msgNotice.UserDTO userDTO
    ) {
        String userLoginName= userDTO.getUserLoginName().replace(" ", "");
        String orgName= userDTO.getOrgName().replace(" ", "");
        userDTO.setUserLoginName(userLoginName);
        userDTO.setOrgName(orgName);
        //新增机构
        if("new".equals(userDTO.getType())){
            String orgCode=getOrg(userDTO);
            if("error".equals(orgCode)){
                return ResponseWrapper.error(301, "机构添加失败",null);
            }
            ResponseWrapper responseWrapper1=myUserClient.findByDeptName(userDTO.getOrgName(), orgCode);
            Map map= (Map) responseWrapper1.getData();
            String deptCode=map.get("deptCode").toString();
            userDTO.setDeptCode(deptCode);
            userDTO.setDeptName(userDTO.getOrgName());
            userDTO.setOrgCode(orgCode);
            userDTO.setUserName(userDTO.getUserLoginName());
            userDTO.setUserType("3");
            userDTO.setUserTypeName("外部单位");
            ResponseWrapper responseWrapper=  myUserClient.saveUserinfo(userDTO.getType(), userDTO);
            return responseWrapper;
        }else{
            String orgCode=getOrg(userDTO);
            if("error".equals(orgCode)){
                return ResponseWrapper.error(301, "机构添加失败",null);
            }
            userDTO.setOrgCode(orgCode);
            userDTO.setUserName(userDTO.getUserLoginName());
            userDTO.setUserPassword(null);
            userDTO.setUserType("3");
            userDTO.setUserTypeName("外部单位");
            ResponseWrapper responseWrapper=  myUserClient.saveUserinfo(userDTO.getType(), userDTO);
            return responseWrapper;
        }


    }

    /**
     * 粮食安全行政首长责任制----部门用户管理 市区----根据orgCode查询orgName
     * @param userDTO
     * @return
     */
    @Override
    public ResponseWrapper orgNameByCode(com.unis.accountability.businessmanagement.common.vo.msgNotice.UserDTO userDTO) {
        ResponseWrapper responseWrapper=myUserClient.orgNameByCode(userDTO.getOrgCode());
        String orgName= (String) responseWrapper.getData();
        if (!orgName.equals(userDTO.getOrgName())) {
            ResponseWrapper responseWrapper1=myUserClient.findByOrgName(userDTO.getOrgName());
            if(responseWrapper1.getInfoCode()==200){
                Map orgMap= (Map) responseWrapper1.getData();
                if(orgMap!=null){
                    String orgCode=orgMap.get("orgCode")==null?"":orgMap.get("orgCode").toString();
                    if(StringUtils.isNotEmpty(orgCode)){
                        return ResponseWrapper.error(301, "机构已存在",null);
                    }
                }
            }
        }else{
            return ResponseWrapper.success();
        }
        return ResponseWrapper.success();
    }

    /**
     * 粮食安全行政首长责任制----部门用户管理 市区----根据userCode查询orgName
     * @param userDTO
     * @return
     */
    @Override
    public ResponseWrapper findByUserCode(com.unis.accountability.businessmanagement.common.vo.msgNotice.UserDTO userDTO) {
        List<String> userCode=new ArrayList();
        userCode.add(userDTO.getUserCode());
        ResponseWrapper responseWrapper=myUserClient.findByUserCode(userCode);
        ArrayList<Map> userInfo= ( ArrayList<Map> ) responseWrapper.getData();
        Map map=userInfo.get(0);
        String userLoginName=map.get("userLoginName").toString();
        if (!userLoginName.equals(userDTO.getUserLoginName())) {
            ResponseWrapper responseWrapper1=myUserClient.findByUserloginname(userDTO.getUserLoginName());
            if(responseWrapper1.getInfoCode()==200){
                Map orgMap= (Map) responseWrapper1.getData();
                String loginName=orgMap.get("userLoginName")==null?"":orgMap.get("userLoginName").toString();
                if(StringUtils.isNotEmpty(loginName)){
                    return ResponseWrapper.error(301, "账号已存在",null);
                }
            }
        }else{
            return ResponseWrapper.success();
        }
        return ResponseWrapper.success();

    }


    /**
     * 添加机构
     * @param userDTO
     * @return
     */
    private String  getOrg(com.unis.accountability.businessmanagement.common.vo.msgNotice.UserDTO userDTO) {
        String orgCode="error";
        if("new".equals(userDTO.getType())){
            ResponseWrapper responseWrapper1=myUserClient.findByOrgName(userDTO.getOrgName());
            if(responseWrapper1.getInfoCode()==200){
                Map orgMap= (Map) responseWrapper1.getData();
                if(orgMap!=null){
                     orgCode=orgMap.get("orgCode")==null?"":orgMap.get("orgCode").toString();
                    if(StringUtils.isNotEmpty(orgCode)){
                        return orgCode;
                    }
                }
            }

            OrgainzeDTO orgainzeDTO=new OrgainzeDTO();
            orgainzeDTO.setOrgName(userDTO.getOrgName());
            orgainzeDTO.setCountyCode(userDTO.getCountyCode());
            orgainzeDTO.setOrgType(type);
            if("120000".equals(userDTO.getCountyCode())){
                orgainzeDTO.setParentCode(cityCode);
            }else{
                orgainzeDTO.setParentCode(quCode);
            }
            myUserClient.orgSave(orgainzeDTO);
            //根据组织名称查询组织信息
            ResponseWrapper responseWrapper=myUserClient.findByOrgName(userDTO.getOrgName());
            if(responseWrapper.getInfoCode()==200){
                Map map= (Map) responseWrapper.getData();
                orgCode=map.get("orgCode").toString();
            }
            return orgCode;
        }else{
            OrgainzeDTO orgainzeDTO=new OrgainzeDTO();
            orgainzeDTO.setCountyCode(userDTO.getCountyCode());
            orgainzeDTO.setOrgType(type);
            if("120000".equals(userDTO.getCountyCode())){
                orgainzeDTO.setParentCode(cityCode);
            }else{
                orgainzeDTO.setParentCode(quCode);
            }
            orgainzeDTO.setOrgName(userDTO.getOrgName());
            orgainzeDTO.setOrgCode(userDTO.getOrgCode());
            myUserClient.orgUpdate(orgainzeDTO);
            //根据组织名称查询组织信息
            return userDTO.getOrgCode();
        }
    }


    /**
     * 粮食安全行政首长责任制----部门用户管理 市区----保存
     * @param userDTO
     * @return
     */
    @Override
    public ResponseWrapper saveDept(com.unis.accountability.businessmanagement.common.vo.msgNotice.UserDTO userDTO) {
        String deptCode="error";
        String userLoginName= userDTO.getUserLoginName().replace(" ", "");
        String deptName= userDTO.getDeptName().replace(" ", "");
        userDTO.setUserLoginName(userLoginName);
        userDTO.setDeptName(deptName);
        userDTO.setUserName(userLoginName);
        userDTO.setOrgName(CurrentUtil.getOrgName());
        userDTO.setOrgCode(CurrentUtil.getOrgId());
        //新增机构
        if("new".equals(userDTO.getType())){
             deptCode=getDept(userDTO);
            if("error".equals(deptCode)){
                return ResponseWrapper.error(301, "机构添加失败",null);
            }
            userDTO.setDeptCode(deptCode);
            userDTO.setUserType("3");
            userDTO.setUserTypeName("外部单痊");
            ResponseWrapper responseWrapper=  myUserClient.saveUserinfo(userDTO.getType(), userDTO);
            return responseWrapper;
        }else{
            deptCode=getDept(userDTO);
            if("error".equals(deptCode)){
                return ResponseWrapper.error(301, "机构添加失败",null);
            }
            userDTO.setDeptCode(deptCode);
            userDTO.setUserType("3");
            userDTO.setUserTypeName("外部单痊");
            ResponseWrapper responseWrapper=  myUserClient.saveUserinfo(userDTO.getType(), userDTO);
            return responseWrapper;
        }
    }


    private String getDept(com.unis.accountability.businessmanagement.common.vo.msgNotice.UserDTO userDTO) {
        String deptCode="error";
        if("new".equals(userDTO.getType())){
            ResponseWrapper responseWrapper1=myUserClient.findByDeptName(userDTO.getDeptName(),userDTO.getOrgCode());
            if(responseWrapper1.getInfoCode()==200){
                Map orgMap= (Map) responseWrapper1.getData();
                if(orgMap!=null){
                    deptCode=orgMap.get("deptCode")==null?"":orgMap.get("deptCode").toString();
                    if(StringUtils.isNotEmpty(deptCode)){
                        return deptCode;
                    }
                }
            }
            //保存部门
            DepartmentDTO departmentDTO=new DepartmentDTO();
            departmentDTO.setCountyCode(CurrentUtil.getAreaCode());
            departmentDTO.setDeptName(userDTO.getDeptName());
            departmentDTO.setOrgCode(CurrentUtil.getOrgId());
            departmentDTO.setParentCode(CurrentUtil.getDeptId());
            myUserClient.deptSave(departmentDTO);
            //根据组织名称查询组织信息
            ResponseWrapper responseWrapper=myUserClient.findByDeptName(userDTO.getDeptName(), userDTO.getOrgCode());
            if(responseWrapper.getInfoCode()==200){
                Map map= (Map) responseWrapper.getData();
                deptCode=map.get("deptCode").toString();
            }
            return deptCode;
        }else{
            //保存部门
            DepartmentDTO departmentDTO=new DepartmentDTO();
            departmentDTO.setCountyCode(CurrentUtil.getAreaCode());
            departmentDTO.setDeptName(userDTO.getDeptName());
            departmentDTO.setDeptCode(userDTO.getDeptCode());
            departmentDTO.setOrgCode(CurrentUtil.getOrgId());
            departmentDTO.setParentCode(CurrentUtil.getDeptId());
            myUserClient.deptUpdate(departmentDTO);
            //根据组织名称查询组织信息
            return departmentDTO.getDeptCode();
        }
    }




    /**
     * 粮食安全行政首长责任制----部门用户管理 市区----根据deptCode查询deptName
     * @param userDTO
     * @return
     */
    @Override
    public ResponseWrapper findByDeptNameByCode(com.unis.accountability.businessmanagement.common.vo.msgNotice.UserDTO userDTO) {
        ResponseWrapper responseWrapper=myUserClient.findByDeptCode1(userDTO.getDeptCode());
        Map map= (Map) responseWrapper.getData();
        String deptName=map.get("deptName").toString();
        if (!deptName.equals(userDTO.getDeptName())) {
            String orgCode=CurrentUtil.getOrgId();
            ResponseWrapper responseWrapper1=myUserClient.findByDeptName(userDTO.getDeptName(),orgCode);
            if(responseWrapper1.getInfoCode()==200){
                Map orgMap= (Map) responseWrapper1.getData();
                if(orgMap!=null){
                    String deptCode=orgMap.get("deptCode")==null?"":orgMap.get("deptCode").toString();
                    if(StringUtils.isNotEmpty(deptCode)){
                        return ResponseWrapper.error(301, "部门已存在",null);
                    }
                }
            }
        }else{
            return ResponseWrapper.success();
        }
        return ResponseWrapper.success();
    }


    /**
     * 粮食安全省长责任制------所有机构树
     * @return
     */
    @Override
    public List<Map> findByOrgTree() {
        List<Map> treeList=new ArrayList();
        List<Map> cityList=new ArrayList();
        Map city=new HashMap();
        city.put("areaCode", "120000");
        city.put("orgName", "天津市");
        cityList.add(city);
        List<Map> areaList=findDataShiTree();
        cityList.addAll(areaList);
        for(Map map:cityList){
            String areaCode=map.get("areaCode").toString();
            ResponseWrapper responseWrapper= myUserClient.findByAreaCodeAndOrgType(areaCode, type);
            if(responseWrapper.getInfoCode()==200){
                List<Map> mapList= (List<Map>) responseWrapper.getData();
                String parentCode="";
                if("120000".equals(areaCode)){
                    Map cityOrg=new HashMap();
                    cityOrg.put("id","LS002");
                    cityOrg.put("name","天津市");
                    parentCode=cityCode;
                    List<Map> cityOrgList=getWbbmList(mapList,parentCode);
                    cityOrg.put("orgList",cityOrgList);
                    treeList.add(cityOrg);
                }else{
                    parentCode=quCode;
                    Map areaMap=getAreaOrgList(mapList, parentCode);
                    treeList.add(areaMap);
                }
            }
        }
        return treeList;
    }


}