package com.unis.app.service;

import com.unis.accountability.businessmanagement.common.vo.msgNotice.MsgNoticePage;
import com.unis.accountability.businessmanagement.common.vo.msgNotice.MsgNoticePublishVO;
import com.unis.accountability.businessmanagement.common.vo.msgNotice.MsgNoticeVO;
import com.unis.common.utils.ResponseWrapper;

import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/11/5 0005 15:05
 * @Description:
 */
public interface MsgNoticeService {
    /**
     * 信息报送----保存
     * @param msgNoticeVO
     * @return
     */
    ResponseWrapper save(MsgNoticeVO msgNoticeVO);

    /**
     * 信息报送---报送
     * @param id
     */
    ResponseWrapper publish(MsgNoticePublishVO msgNoticePublishVO);


    /**
     * 信息报送---批量采用
     * @param idsList
     * @return
     */
    ResponseWrapper publishALL(MsgNoticePublishVO msgNoticePublishVO);


    /**
     * 信息报送----查看
     * @param id
     * @param status
     * @return
     */
    MsgNoticeVO findById(String id);

    /**
     * 信息报送----查看
     * @param id
     * @return
     */
    MsgNoticeVO findByInfo(String id);

    /**
     * 信息报送----分页
     * @param msgNoticePage
     * @param page
     * @param size
     * @return
     */
    Map findByPage(MsgNoticePage msgNoticePage, Integer page, Integer size);

    /**
     * 信息报送----修改
     * @param msgNoticeVO
     * @return
     */
    ResponseWrapper update(MsgNoticeVO msgNoticeVO);

    /**
     * 信息报送---删除
     * @param id
     * @return
     */
    ResponseWrapper deletes(String[] ids);


}